package com.japisoft.datasource.ftp;

import org.apache.commons.vfs.FileObject;

import com.japisoft.datasource.DataSource;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FTPDataSource implements DataSource {

	protected String host,user,password,path;
	protected FileObject fo = null;
	
	public FTPDataSource( 
			String host, 
			String user, 
			String password, 
			String path ) {
		this.host = host;
		this.user = user;
		this.password = password;
		this.path = path;
	}
	
	public FTPDataSource(
		String uri ) {
		String tmp = uri;
		tmp = tmp.toLowerCase();
		if ( tmp.startsWith( "ftp://" ) ) {
			tmp = tmp.substring( 6 );
		}
		
		int i = tmp.lastIndexOf( "@" );
		if ( i > -1 ) {
			String userPasswordRaw = tmp.substring( 0, i );
			String[] userPassword = userPasswordRaw.split( ":" );
			if ( userPassword.length == 1 ) {
				user = userPassword[ 0 ];
			} else
			if ( userPassword.length == 2 ) {
				user = userPassword[ 0 ];
				password = userPassword[ 1 ];
			}
			tmp = tmp.substring( i + 1 );			
		}

		String[] t = tmp.split( "@" );
		if ( t.length == 2 ) {
		}
		i = tmp.indexOf( "/" );
		if ( i > -1 ) {
			try {
				path = tmp.substring( i + 1 );				
			} catch( IndexOutOfBoundsException exc ) {
				path = "";
			}
			tmp = tmp.substring( 0, i );
		}
		host = tmp;
	}

	public FTPDataSource( FileObject fo ) {
		this.fo = fo;
	}
	
	public String getPath() {
		if ( fo != null )
			return fo.getName().getPath();
		return path;
	}
	
	public String getName() {
		String tmp = getPath();
		if ( tmp.endsWith( "/" ) )
			tmp = tmp.substring( 0, tmp.length() - 1 );
		if ( tmp.endsWith( "\\" ) )
			tmp = tmp.substring( 0, tmp.length() - 1 );
		int i = tmp.lastIndexOf( "/" );
		if ( i == -1 )
			i = tmp.lastIndexOf( "\\" );
		if ( i > -1 )
			tmp = tmp.substring( i + 1 );
		return tmp;
	}	

}
