package com.japisoft.dtdparser.node;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/

public class DTDNodeFactory {

    public DTDNodeFactory() {
	super();   
    }

    /** Root node tied to any node */
    protected RootDTDNode root;

    /** Recall the getNodeForType with a <code>null</code> argument */
    public DTDNode getNodeForType( int type ) {
	return getNodeForType( type, null );
    }

    /** HERE the mehod you will have to override if you want to use custom node
	@return the good DTDNode for the specified type :
	DTDNode.COMMENT, DTDNode.ENTITY, DTDNode.ELEMENT, DTDNode.ATTRIBUTE */
    public DTDNode getNodeForType( int type, String arg ) {
	DTDNode node = null;

	switch( type ) {
	 case DTDNode.COMMENT :
	     node = new CommentDTDNode( arg );
	     break;
	 case DTDNode.ROOT : 
	     return ( root = new RootDTDNode() );
	 case DTDNode.ENTITY :
	     node = new EntityDTDNode( arg, null );
	     break;
	 case DTDNode.ELEMENT :
	     node = new ElementDTDNode( arg );
	     break;
	 case DTDNode.ELEMENT_SET :
	     node = new ElementSetDTDNode();
	     break;
	 case DTDNode.ATTRIBUTE :
	     node = new AttributeDTDNode( arg );
	     break;
	 case DTDNode.ELEMENT_REF :
	     node = new ElementRefDTDNode( arg );
	     break;
	}

	node.setRoot( root );
	return node;
    }

}

// DTDNodeFactory ends here
