package com.japisoft.editix.action.dtdschema.generator;

import java.util.ArrayList;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class MetaAttribute extends MetaObject {

	public String name;
	public ArrayList values;

	public MetaAttribute( String name, String value ) {
		this.name = name;
		this.values = new ArrayList();
		this.values.add( value );
	}

	public String getName() { return name; }
	public ArrayList getValues() { return values; }
	
	public void addValue( String value ) {
		values.add( value );
	}
	
	public boolean equals( Object obj ) {
		if ( obj instanceof MetaAttribute ) {
			MetaAttribute ma = ( MetaAttribute )obj;
			if ( ma.name.equals( name ) )
				return true;
			return false;
		} else
			return super.equals( obj );
	}
	
	private String type;

	public void setType( String type ) {
		this.type = type;
	}

	public String getType() {
		if ( type == null )
			type = TEXT_TYPE;
		return type;
	}
}

