package com.japisoft.editix.action.dtdschema.generator.transformer;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.japisoft.editix.action.dtdschema.generator.MetaNode;
import com.japisoft.editix.action.dtdschema.generator.Transformer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public abstract class AbstractTransformer implements Transformer {

	protected boolean sequenceMode = false;
	
	public void setSequenceMode( boolean sequenceMode ) {
		this.sequenceMode = sequenceMode;
	}

	public String transform(MetaNode root, List<MetaNode> nodeCollection) {
		Map<String,Boolean> processed = new HashMap<String,Boolean>();
		StringBuffer sb = new StringBuffer();
		initTransform( root, sb );
		for ( int i = 0; i < nodeCollection.size(); i++ ) {
			String name = ( ( MetaNode )nodeCollection.get( i ) ).getName();
			if ( name != null ) {
				if ( processed.containsKey( name ) )
					continue;
			}			
			generateMetaNode( (MetaNode)nodeCollection.get( i ), sb );
			if ( name != null ) {
				processed.put( name, Boolean.TRUE );
			}			
		}
		closeTransform( root, sb );
		return sb.toString();
	}

	protected void initTransform( MetaNode root, StringBuffer sb ) {}
	protected void generateMetaNode( MetaNode node, StringBuffer sb ) {};
	protected void closeTransform( MetaNode root, StringBuffer sb ) {}
	
}
