package com.japisoft.editix.action.file;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SaveAllAction extends AbstractAction {

	public static boolean RETURN_STATUS = true;

	public void actionPerformed(ActionEvent e) {
		if ( EditixFrame.THIS.isEmpty() )
			return;

		boolean modified = false;
		for ( int i = 0; i < EditixFrame.THIS.getXMLContainerCount(); i++ ) {
			XMLContainer container = EditixFrame.THIS.getXMLContainer( i );
			if ( container != null && 
					container.getEditor().isDocumentModified() ) {
				modified = true;
				break;
			}
		}

		if ( !modified ) {
			return;
		}

		SaveAllDialog cad = new SaveAllDialog();
		cad.setVisible(true);

		if (cad.isOk()) {
			RETURN_STATUS = true;
			// save the selection
			for (int i = 0; i < cad.getSelections().size(); i++) {
				boolean ok =
					((Boolean) cad.getSelections().get(i)).booleanValue();
				if (ok) {
					EditixFrame.THIS.activeXMLContainer(
						i);
					SaveAction.save_action();
				}
			}
		} else
			RETURN_STATUS = false;
	}

}
