package com.japisoft.editix.action.file.imp.spreadsheet.xls;

import org.apache.poi.ss.usermodel.Cell;

import com.japisoft.editix.action.file.imp.spreadsheet.Col;
import com.japisoft.editix.action.file.imp.spreadsheet.Row;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XLSRow implements Row {

	private XLSCol[] cols = null;
	
	XLSRow( org.apache.poi.ss.usermodel.Row r ) {
		int firstCell = r.getFirstCellNum();
		int lastCell = r.getLastCellNum();
		cols = new XLSCol[ ( lastCell - firstCell ) + 1 ];
		for ( int i = firstCell; i <= lastCell; i++ ) {
			Cell c = r.getCell( i );
			if ( c != null )
				cols[ i ] = new XLSCol( c );
		}
	}
	
	@Override
	public int getColCount() {
		return cols.length;
	}

	@Override
	public Col getCol(int index) {
		return cols[ index - 1 ];
	}
	
}
