package com.japisoft.editix.action.file.imp.spreadsheet.xls;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.usermodel.WorkbookFactory;

import com.japisoft.editix.action.file.imp.spreadsheet.Sheet;
import com.japisoft.editix.action.file.imp.spreadsheet.SpreadSheet;
import com.japisoft.editix.action.file.imp.spreadsheet.SpreadSheetConfPanel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XLSSpreadSheet implements SpreadSheet {
	
	private List<Sheet> l = null;
	
	public XLSSpreadSheet( SpreadSheetConfPanel conf, File f ) throws Exception {
		process( conf, WorkbookFactory.create( f ) );		
	}
	
	private void process( SpreadSheetConfPanel conf, Workbook w ) {
		for ( int i = 0; i < w.getNumberOfSheets(); i++ ) {
			org.apache.poi.ss.usermodel.Sheet s = w.getSheetAt( i );
			if ( l == null )
				l = new ArrayList<Sheet>();
			l.add( new XLSSheet( conf, s ) );
		}
	}
	
	@Override
	public int getSheetCount() {
		if ( l == null )
			return 0;
		return l.size();
	}

	@Override
	public Sheet getSheet(int index) {
		return l.get( index - 1 );
	}
	
}
