package com.japisoft.editix.action.file.project;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JMenu;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.application.descriptor.InterfaceBuilder;
import com.japisoft.framework.application.descriptor.helpers.MenuBuilderDelegate;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RecentFileMenuBuilder implements MenuBuilderDelegate {
	
	public RecentFileMenuBuilder() {
	}
	
	public void build( JMenu menu ) {
		menu.removeAll();
		InterfaceBuilder ib = new InterfaceBuilder();
		try {
			for ( int i = 0; i < RecentProjectManager.getInstance().getItemCount(); i++ ) {
				menu.add( new LoadProjectAction( RecentProjectManager.getInstance().getItem( i ) ) );
			}
			menu.setEnabled( RecentProjectManager.getInstance().getItemCount() > 0 );			
		} catch ( Throwable e ) {
		}		
	}
	
	class LoadProjectAction extends AbstractAction {
		public LoadProjectAction( String location ) {
			putValue( Action.NAME, location );
		}
		public void actionPerformed( ActionEvent e ) {
			ApplicationModel.fireApplicationValue( 
				"lastProject", 
				( String )getValue( Action.NAME ) 
			);
		}
	}

}
