package com.japisoft.editix.action.fop;

import java.awt.event.ActionEvent;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;

import javax.swing.AbstractAction;

import com.japisoft.editix.action.file.OpenAction;
import com.japisoft.editix.ui.EditixFactory;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FOConfigAction extends AbstractAction {

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if ( !EditixFOPFactory.fopXML.exists() ) {
			try {
				BufferedWriter bw = new BufferedWriter( 
					new OutputStreamWriter( 
							new FileOutputStream( EditixFOPFactory.fopXML ), "UTF-8" ) );
				try {
					bw.write( "<?xml version=\"1.0\"?>" );bw.newLine();
					bw.write( "<fop version=\"1.0\">" );bw.newLine();
					bw.write( " <!-- Strict user configuration -->");bw.newLine();
					bw.write( " <strict-configuration>true</strict-configuration>" );bw.newLine();
					bw.write( " <!-- Strict FO validation -->");bw.newLine();
					bw.write( " <strict-validation>true</strict-validation>");bw.newLine();
					bw.write( " <!-- Base URL for resolving relative URLs -->" );bw.newLine();
					bw.write( " <base>./</base>" );bw.newLine();
					bw.write( " <!-- Font Base URL for resolving relative font URLs -->" );bw.newLine();
					bw.write( " <font-base>./</font-base>" );bw.newLine();
					bw.write( " <!-- Source resolution in dpi (dots/pixels per inch) for determining the size of pixels in SVG and bitmap images, default: 72dpi -->" );bw.newLine();
					bw.write( " <source-resolution>72</source-resolution>" );bw.newLine();
					bw.write( " <!-- Target resolution in dpi (dots/pixels per inch) for specifying the target resolution for generated bitmaps, default: 72dpi -->" );bw.newLine();
					bw.write( "  <target-resolution>72</target-resolution>" );bw.newLine();
					bw.write( "</fop>" );bw.newLine();
				} finally {
					bw.close();
				}
			} catch( Exception exc ) {
				EditixFactory.buildAndShowErrorDialog( "Can't write default fop.xml : " + exc.getMessage() );
				return;
			}
		}
		OpenAction.openFile( "XML", false, EditixFOPFactory.fopXML, "UTF-8" );
	}

}
