package com.japisoft.editix.action.html;

import java.awt.event.ActionEvent;
import java.io.FileInputStream;

import javax.swing.AbstractAction;

import com.japisoft.editix.action.file.imp.HTMLImport;
import com.japisoft.editix.toolkit.Toolkit;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ConvertToXHTMLAction extends AbstractAction {

	@Override
	public void actionPerformed(ActionEvent arg0) {

		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if ( container == null )
			return;
		
		if (EditixFactory.mustSaveDialog(container)) {
			return;
		}
		
		try {
			String location = container.getCurrentDocumentLocation();
			byte[] data = HTMLImport.convertHTMLInputStream( 
					new FileInputStream( location ) );
			if ( data != null ) {
				IXMLPanel panel = EditixFactory.buildNewContainer("XHTML", (String)null);
				XMLContainer newContainer = panel.getMainContainer();
				newContainer.setText(Toolkit.getEncodedString(data).getContent());
				EditixFrame.THIS.addContainer(panel);
			}
		} catch( Throwable exc ) {
			EditixFactory.buildAndShowErrorDialog( "Can't convert : " + exc.getMessage() );
		}

	}

}
