package com.japisoft.editix.action.json;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import org.json.JSONKey;
import org.json.JSONObject;

import com.japisoft.editix.editor.json.JSONContainer;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.xml.parser.document.Document;
import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DeleteAction extends AbstractAction {
	
	@Override
	public void actionPerformed(ActionEvent arg0) {
		JSONContainer jsc = ( JSONContainer )EditixFrame.THIS.getSelectedContainer();
		FPNode node = jsc.getCurrentNode();
		if ( node != null ) {
			if ( node.getApplicationObject() instanceof JSONKey ) {
				JSONKey key = ( JSONKey )node.getApplicationObject();
				JSONObject parent = key.getParent();
				if ( parent != null ) {
					parent.remove( key.getKey() );
					try {
						Document root = node.getDocument();
						JSONObject doc = ( JSONObject )( ( FPNode )root.getRoot() ).getApplicationObject();
						jsc.setText( doc.toString( 1 ) );						
						FormatAction.format( jsc );
					} catch( Exception exc ) {
						EditixFactory.buildAndShowErrorDialog( "Can't format your document, check for the syntax" );
					}
				}
			}
		}
	}

}
