package com.japisoft.editix.action.tree;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.action.MultipleChoice;
import com.japisoft.xmlpad.tree.renderer.FastTreeRenderer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FilterAction extends AbstractAction implements MultipleChoice {

	public FilterAction() {
		try {
			putValue("label1", "'Default' Filter");
			putValue("label2", "'Prefix' Filter");
			putValue("label3", "'Namespace' Filter");
			putValue("label4", "'Qualified Name' Filter");
			putValue("cmd1", "0");
			putValue("cmd2", "1");
			putValue("cmd3", "2");
			putValue("cmd4", "3");
		} catch (Throwable th) {
			th.printStackTrace();
		}
	}

	public static final FilterAction SINGLETON = new FilterAction();

	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();

		if ("".equals(cmd) || cmd == null)
			return;

		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if (container == null) {
			// ??
		} else {

			int mode = Integer.parseInt(cmd);
			((FastTreeRenderer) container.getTree().getCellRenderer())
					.setRenderingMode(mode);
			TreePath tp = container.getTree().getSelectionPath();
			((DefaultTreeModel) container.getTree().getModel()).reload();
			if (tp != null)
				container.getTree().setSelectionPath(tp);

			container.getTree().repaint();
		}
	}

}
