package com.japisoft.editix.action.xsl;

import javax.swing.table.TableModel;
import com.japisoft.editix.ui.EditixDialog;
import com.japisoft.xmlpad.IXMLPanel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSLTDialog extends EditixDialog {

	public XSLTDialog() {
		this("XSLT", 
				"XSLT parameters", 
					"Choose your XSLT parameters\nFix it once and use ctrl-J for applying it.\nStore these parameters using a project for the next time\n", false);
	}

	public XSLTDialog( 
			String title, 
			String subTitle, 
			String comment, 
			boolean xqueryMode ) {
		super(title, 
				subTitle, 
					comment );
		jbInit( xqueryMode );
		pack();
		setSize( getWidth(), getHeight() - 70 );
	}

	private XSLTConfigPanel panel = null;
	
	private void jbInit( boolean xqueryMode ) {
				
		panel = new XSLTConfigPanel( xqueryMode );
		getContentPane().add( panel );
		if ( xqueryMode ) {
			panel.setEnabledFOP( false );
		}

	}

	public String getXSLTFile() { 
		return panel.getXSLTFile();
	}

	public String getDataFile() {
		return panel.getDataFile();
	}

	public String getResultFile() {
		return panel.getResultFile();
	}

	public boolean isOpenNewDocument() {
		return panel.isOpenNewDocument();
	}

	public TableModel getParameters() {
		return panel.getParameters();
	}

	public void init( IXMLPanel container ) {
		panel.init( container );
	}

	public void store( IXMLPanel container ) {
		panel.store( container );
	}

}
