package com.japisoft.editix.action.xsl.result;

import java.io.File;
import java.io.OutputStream;

import javax.xml.transform.stream.StreamResult;

import com.japisoft.framework.toolkit.FileToolkit;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class StreamResultFactory {

	private StreamResultFactory() {}
	
	private static StreamResultFactory Instance = null;
	
	public static StreamResultFactory instance() {
		if ( Instance == null )
			Instance = new StreamResultFactory();
		return Instance;
	}
	
	public StreamResult streamResult( int version, String res ) throws Exception {
		StreamResult sr = null;
		
		OutputStream output = DocumentTypeModel.instance().open( res );
		if ( output != null )
			return new StreamResult( output );
		
		// Default
		
		if ( version == 1 ) {
			sr = new StreamResult( res );
		}
		else {
			sr = new StreamResult( new File( res ) );
		}
		return sr;
	}
	
	public void endProcess( String res )  throws Exception {
		DocumentTypeModel.instance().close( res );
	}
	
	public boolean canRead( String res ) {
		String fileExt = FileToolkit.fileExt( res );
		return !DocumentTypeModel.instance().processed( fileExt );
	}
	
}
