package com.japisoft.editix.document;

import java.io.File;

import javax.swing.Icon;

import com.japisoft.editix.wizard.document.DocumentWizard;
import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TemplateInfo {

	public String label;
	public String location;
	public String type;
	public boolean system;
	public Icon icon;
	public String encoding;
	public String content;
	public String defDTDLocation;
	public String defDTDRoot;
	public String help;
	public String wizard;
	
	public DocumentWizard wizardInstance = null;

	public boolean hasWizard() { return wizard != null; }
	
	public String startWizard() {
		if ( wizard == null )
			return null;
		if ( wizard != null ) {
			if ( wizardInstance == null ) {
				try {
					wizardInstance = ( DocumentWizard )( Class.forName( wizard ) ).newInstance();
				} catch( Exception exc ) {
					exc.printStackTrace();
					wizard = null;
					return null;
				}
			}
			return wizardInstance.start();
		}
		return null;
	}

	public File getWizardSource() { return wizardInstance.getSource(); }
	
	public FPNode toXML() {
		FPNode node2 = new FPNode( FPNode.TAG_NODE, "template" );
		String labelTmp = label.replaceAll( "<", "&lt;" ).replaceAll( ">", "&gt;" );
		node2.setAttribute( "label", labelTmp );
		node2.setAttribute( "type", type );
		if ( help != null )
			node2.setAttribute( "help", help );
		if ( location != null ) {
			node2.setAttribute( "location", location );
		}
		node2.setAttribute( "system", ( system ) ? "true" : "false" );
		if ( wizard != null ) {
			node2.setAttribute( "wizard", wizard );
		}
		return node2;
	}
	
}
