package com.japisoft.editix.editor.css.helper;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Keywords {

	// CSS 3 properties
	public static String[] CSS3Properties = {
		"alignment-adjust",					
		"alignment-baseline",					
		"@keyframes",
		"animation",
		"animation-name",
		"animation-duration",
		"animation-timing-function",
		"animation-delay",
		"animation-iteration-count",
		"animation-direction",
		"animation-play-state",
		"appearance",			
		"backface-visibility",				
		"background-clip",
		"background-origin",
		"background-size",
		"baseline-shift",					
		"bookmark-label",
		"bookmark-level",
		"bookmark-target",
		"border-bottom-left-radius",
		"border-bottom-right-radius",
		"border-image",
		"border-image-outset",					
		"border-image-repeat",
		"border-image-slice",
		"border-image-source",
		"border-image-width",
		"border-radius",
		"border-top-left-radius",
		"border-top-right-radius",
		"box-decoration-break",
		"box-align",
		"box-direction",
		"box-flex",
		"box-flex-group",
		"box-lines",
		"box-ordinal-group",
		"box-orient",
		"box-pack",
		"box-shadow",
		"box-sizing",
		"color-profile",
		"column-fill",
		"column-gap",
		"column-rule",
		"column-rule-color",
		"column-rule-style",
		"column-rule-width",
		"column-span",
		"column-width",
		"columns",
		"column-count",
		"crop",
		"dominant-baseline",
		"drop-initial-after-adjust",
		"drop-initial-after-align",
		"drop-initial-before-adjust",
		"drop-initial-before-align",
		"drop-initial-size",
		"drop-initial-value",
		"fit",
		"fit-position",
		"float-offset",
		"@font-face",
		"font-size-adjust",			
		"font-stretch",
		"grid-columns",
		"grid-rows",
		"hanging-punctuation",
		"hyphenate-after",
		"hyphenate-before",
		"hyphenate-characters",
		"hyphenate-lines",
		"hyphenate-resource",
		"hyphens",
		"icon",
		"image-orientation",
		"image-resolution",
		"inline-box-align",
		"line-stacking",
		"line-stacking-ruby",
		"line-stacking-shift",
		"line-stacking-strategy",
		"mark",
		"mark-after",
		"mark-before",
		"marks",
		"marquee-direction",
		"marquee-play-count",
		"marquee-speed",
		"marquee-style",
		"move-to",
		"nav-down",
		"nav-index",
		"nav-left",
		"nav-right",
		"nav-up",
		"opacity",
		"outline-offset",
		"overflow-style",
		"overflow-x",			
		"overflow-y",
		"page",
		"page-policy",
		"perspective",
		"perspective-origin",				
		"punctuation-trim",
		"rendering-intent",
		"resize",	
		"rest",
		"rest-after",
		"rest-before",
		"rotation",
		"rotation-point",
		"ruby-align",
		"ruby-overhang",
		"ruby-position",
		"ruby-span",
		"size",
		"string-set",
		"target",
		"target-name",
		"target-new",
		"target-position",
		"text-align-last",
		"text-emphasis",
		"text-height",
		"text-justify",
		"text-outline",
		"text-overflow",
		"text-shadow",
		"text-wrap",
		"transform",
		"transform-origin",
		"transform-style",	
		"transition",
		"transition-property",
		"transition-duration",
		"transition-timing-function",
		"transition-delay",
		"word-break",
		"word-wrap"	
	};
	
	public static String[] properties = {
		"accelerator",
		"azimuth",
		"background",
		"background-attachment",
		"background-color",
		"background-image",
		"background-position",
		"background-position-x",
		"background-position-y",
		"background-repeat",
		"behavior",
		"border",
		"border-bottom",
		"border-bottom-color",
		"border-bottom-style",
		"border-bottom-width",
		"border-collapse",
		"border-color",
		"border-left",
		"border-left-color",
		"border-left-style",
		"border-left-width",
		"border-right",
		"border-right-color",
		"border-right-style",
		"border-right-width",
		"border-spacing",
		"border-style",
		"border-top",
		"border-top-color",
		"border-top-style",
		"border-top-width",
		"border-width",
		"bottom",
		"caption-side",
		"clear",
		"clip",
		"color",
		"content",
		"counter-increment",
		"counter-reset",
		"cue",
		"cue-after",
		"cue-before",
		"cursor",
		"direction",
		"display",
		"elevation",
		"empty-cells",
		"filter",
		"float",
		"font",
		"font-family",
		"font-size",
		"font-size-adjust",
		"font-stretch",
		"font-style",
		"font-variant",
		"font-weight",
		"height",
		"ime-mode",
		"include-source",
		"layer-background-color",
		"layer-background-image",
		"layout-flow",
		"layout-grid",
		"layout-grid-char",
		"layout-grid-char-spacing",
		"layout-grid-line",
		"layout-grid-mode",
		"layout-grid-type",
		"left",
		"letter-spacing",
		"line-break",
		"line-height",
		"list-style",
		"list-style-image",
		"list-style-position",
		"list-style-type",
		"_margin",
		"margin",
		"margin-bottom",
		"margin-left",
		"margin-right",
		"margin-top",
		"_margin-bottom",
		"_margin-left",
		"_margin-right",
		"_margin-top",		
		"marker-offset",
		"marks",
		"max-height",
		"max-width",
		"min-height",
		"min-width",
		"-moz-binding",
		"-moz-border-radius",
		"-moz-border-radius-topleft",
		"-moz-border-radius-topright",
		"-moz-border-radius-bottomright",
		"-moz-border-radius-bottomleft",
		"-moz-border-top-colors",
		"-moz-border-right-colors",
		"-moz-border-bottom-colors",
		"-moz-border-left-colors",
		"-moz-box-sizing",
		"-moz-opacity",
		"-moz-outline",
		"-moz-outline-color",
		"-moz-outline-style",
		"-moz-outline-width",
		"-moz-user-focus",
		"-moz-user-input",
		"-moz-user-modify",
		"-moz-user-select",
		"orphans",
		"outline",
		"outline-color",
		"outline-style",
		"outline-width",
		"overflow",
		"overflow-X",
		"overflow-Y",
		"padding",
		"padding-bottom",
		"padding-left",
		"padding-right",
		"padding-top",
		"page",
		"page-break-after",
		"page-break-before",
		"page-break-inside",
		"pause",
		"pause-after",
		"pause-before",
		"pitch",
		"pitch-range",
		"play-during",
		"position",
		"quotes",
		"-replace",
		"richness",
		"right",
		"ruby-align",
		"ruby-overhang",
		"ruby-position",
		"-set-link-source",
		"size",
		"speak",
		"speak-header",
		"speak-numeral",
		"speak-punctuation",
		"speech-rate",
		"stress",
		"scrollbar-arrow-color",
		"scrollbar-base-color",
		"scrollbar-dark-shadow-color",
		"scrollbar-face-color",
		"scrollbar-highlight-color",
		"scrollbar-shadow-color",
		"scrollbar-3d-light-color",
		"scrollbar-track-color",
		"table-layout",
		"text-align",
		"text-align-last",
		"text-decoration",
		"text-indent",
		"text-justify",
		"text-overflow",
		"text-shadow",
		"text-transform",
		"text-autospace",
		"text-kashida-space",
		"text-underline-position",
		"top",
		"unicode-bidi",
		"-use-link-source",
		"vertical-align",
		"visibility",
		"voice-family",
		"volume",
		"white-space",
		"widows",
		"width",
		"word-break",
		"word-spacing",
		"word-wrap",
		"writing-mode",
		"z-index",
		"zoom"		
	};

	public static boolean isAProperty( String name ) {
		name = name.toLowerCase();
		for ( int i = 0; i < properties.length; i++ ) {
			if ( properties[ i ].equals( name ) )
				return true;
		}
		for ( int i = 0; i < CSS3Properties.length; i++ ) {
			if ( CSS3Properties[ i ].equals( name ) )
				return true;
		}		
		return false;
	}

}
