package com.japisoft.editix.editor.html.action;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;

import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class InsertTagAction extends AbstractAction {

	public void actionPerformed(ActionEvent arg0) {

		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if ( container != null ) {
			String tag = ( String )getValue( "param" );
			int caret = container.getCaretPosition();
			
			String footer = "";

			if ( !tag.endsWith( "/" ) ) {
				footer = "</" + tag + ">";
			} else {
				if ( container.getDocumentInfo().isHTML() ) {
					tag = tag.replace( "/", "" );
				}
			}

			String header = "<" + tag.replace( "'", "\"" ) + ">";
			
			int caretStep = header.length();
			int tmp = header.indexOf( "$" ); 

			if ( tmp > 0 ) {
				caretStep = tmp;
				header = header.substring( 0,  tmp ) + header.substring( tmp + 1 );
			}

			container.insertText( header + footer );			
			container.setCaretPosition( caret + caretStep );
		}

	}

}
