package com.japisoft.editix.editor.xsd.toolkit;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSDAttribute {
	public String name;
	public int type;
	public String[] def;
	public boolean anyString;

	public static final int STRING_TYPE = 0;	
	public static final int BOOLEAN_TYPE = 1;
	public static final int NON_NEGATIVE_INTEGER = 2; 
	public static final int ELEMENT_REF = 3; 
	public static final int TYPEC_REF = 4;	// Complex
	public static final int TYPEP_REF = 8;	// Simple
	public static final int TYPE_REF = 9;	// Complex or Simple
	public static final int ATTRIBUTE_REF = 5;
	public static final int GROUP_REF = 6;
	public static final int SCHEMA_REF = 7;
	public static final int ATTRIBUTE_GROUP_REF = 10;
	
	public XSDAttribute( String name, int type, String[] def, boolean anyString ) {
		this.name = name;
		this.type = type;
		this.def = def;
		this.anyString = anyString;
	}
	
	public XSDAttribute( String name, String[] def, boolean anyString ) {
		this( name, STRING_TYPE, def, anyString );
	}

}
