package com.japisoft.editix.editor.xsd.view.designer;

import java.awt.Color;
import java.util.HashMap;

import com.japisoft.framework.preferences.Preferences;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public final class ColorFactory {
	
	static HashMap mapOfColor;
	static Color selectionForegroundColor;
	static Color selectionBackgroundColor;
	static Color foregroundColor;
	
	static {
		mapOfColor = new HashMap();
		mapOfColor.put( 
				"element",
				Preferences.getPreference(
						"xsdEditor", "element",
						new Color( 150, 255, 150 ) ) );
		mapOfColor.put( 
				"any",
				Preferences.getPreference(
						"xsdEditor", "any",
						new Color( 150, 255, 150 ) )
		);
		mapOfColor.put(
				"attribute",
				Preferences.getPreference(
						"xsdEditor", "attribute",
						new Color( 250, 250, 150 ) )
		);
		mapOfColor.put(
				"anyAttribute",
				Preferences.getPreference(
						"xsdEditor", "anyAttribute",
						new Color( 250, 250, 150 ) )	
		);
		mapOfColor.put(
				"attributeGroup",
				Preferences.getPreference(
						"xsdEditor", "attributeGroup",
						new Color( 220, 220, 120 ) ) );
		mapOfColor.put(
				"sequence",
				Preferences.getPreference(
						"xsdEditor", "sequence",
				new Color( 255, 150, 150 ) ) );
		mapOfColor.put(
				"all",
				Preferences.getPreference( 
						"xsdEditor", "all",
						new Color( 255, 150, 150 ) ) );
		mapOfColor.put(
				"choice",
				Preferences.getPreference(
						"xsdEditor", "choice",
						new Color( 255, 150, 150 ) ) );
		mapOfColor.put(
				"complexType",
				Preferences.getPreference(
						"xsdEditor", "complexType",
						new Color( 240, 240, 240 ) )	
		);
		mapOfColor.put(
				"complexContent",
				Preferences.getPreference(
						"xsdEditor", "complexContent",
						new Color( 230, 230, 230 ) )
		);
		mapOfColor.put(
				"simpleContent",
				Preferences.getPreference(
						"xsdEditor", "simpleContent",
						new Color( 220, 220, 220 ) )	
		);
		mapOfColor.put(
				"group",
				Preferences.getPreference(
						"xsdEditor", "group",
						new Color( 220, 220, 220 ) )
		);
		mapOfColor.put(
				"restriction",
				Preferences.getPreference(
						"xsdEditor", "restriction",
						new Color( 210, 210, 210 ) )	
		);
		mapOfColor.put(
				"extension",
				Preferences.getPreference(
						"xsdEditor", "extension",
						new Color( 210, 210, 210 ) )	
		);
		
		selectionBackgroundColor = 
			Preferences.getPreference(
					"xsdEditor", "selectionBackground",
					new Color( 180, 180, 255 ) );

		selectionForegroundColor = 
			Preferences.getPreference(
					"xsdEditor", "selectionForeground",
					Color.WHITE );
		
		foregroundColor = 
			Preferences.getPreference( 
					"xsdEditor", "foreground", 
					Color.BLACK );
	}

	static Color getForegroundColor( String elementName ) {
		return foregroundColor;
	}

	static Color getBackgroundColor( String elementName ) {
		Color c = ( Color )mapOfColor.get( elementName );
		if ( c != null )
			return c;
		return Color.WHITE;
	}

	static Color getSelectedBackgroundColor( String elementName ) {
		return selectionBackgroundColor;
	}

	static Color getSelectedForegroundColor( String elementName ) {
		return selectionForegroundColor;
	}
	
}
