package com.japisoft.editix.editor.xsd.view.designer;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.Shape;

import javax.swing.ImageIcon;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSDSequenceComponentImpl extends XSDSimpleComponentImpl {

	static final ImageIcon SEQUENCE_ICON = new ImageIcon(
			XSDSequenceComponentImpl.class.getResource("sequence.png"));
	
	protected ImageIcon mainImage;
	
	public XSDSequenceComponentImpl() {
		super();
		mainImage = SEQUENCE_ICON;
		paintElementName = false;
	}

	protected void paintSpecialContent( Graphics2D g ) {
		int openWidth = OPEN_ICON.getIconWidth();
		int openHeight = OPEN_ICON.getIconHeight();

		int y = 1;
		int x = 1;

		if ( !hasOpenIcon ) {
			openWidth = 0;
			openHeight = 0;
		}

		int w = getWidth() - openWidth - 2;
		int h = getHeight() - 2;

		g.drawImage( mainImage.getImage(), 
				( ( w - mainImage.getIconWidth() ) / 2 ) + 2,
				( ( h - mainImage.getIconHeight() ) / 2 ) + 1, null );
	}	
	
	protected Shape createBorderShape() {

		int openWidth = OPEN_ICON.getIconWidth();
		int openHeight = OPEN_ICON.getIconHeight();

		int y = 1;
		int x = 1;

		if ( !hasOpenIcon ) {
			openWidth = 0;
			openHeight = 0;
		}

		int w = getWidth() - openWidth - 2;
		int h = getHeight() - 2;
		
		return new Polygon(
				new int[] {
						1, 
						w / 4,
						( 3 * w ) / 4,
						w,
						( 3 * w ) / 4,
						w / 4,
						1
				},
				new int[] {
						h / 2,
						0,
						0,
						h / 2,
						h,
						h,
						h/2
				},
				7
				);

	}

	public Dimension getPreferredSize() {
		return new Dimension( 40, 20 );
	}
	
}
