package com.japisoft.editix.editor.xsd.view.designer.container;

import java.awt.BasicStroke;
import java.awt.Dimension;
import java.awt.Shape;
import java.awt.geom.RoundRectangle2D;

import com.japisoft.editix.editor.xsd.view.designer.LeftToRightLayout;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSDAttributeGroupComponentImpl extends XSDContainerComponentImpl {

	public XSDAttributeGroupComponentImpl() {
		super();
		setLayout( new LeftToRightLayout() );
		float[] dash = { 5.0f };
		borderStyle = new BasicStroke(1.0f, BasicStroke.CAP_BUTT,
		        BasicStroke.JOIN_MITER, 5.0f, dash, 0.0f);
		paintName = true;		
	}

	protected Shape createBorderShape() {
		int openWidth = OPEN_ICON.getIconWidth();
		int openHeight = OPEN_ICON.getIconHeight();
		int y = 1;
		int x = 1;
		if ( !hasOpenIcon ) {
			openWidth = 0;
			openHeight = 0;
		}
		return new RoundRectangle2D.Double( (double)x, (double)y, (double)( getWidth() - openWidth - 2 ),
				(double)( getHeight() - 2 ), 10.0, 10.0 );
	}
	
	protected boolean isNameVisible() { return e.hasAttribute( "ref" ); }		

	public Dimension getPreferredSize() {
		Dimension layoutDimension = getLayout().preferredLayoutSize( this );
		return new Dimension(
				Math.max( layoutDimension.width, 50 ) + 10,
				Math.max( layoutDimension.height, 20 ) + 20
		);
	}
	
}
