package com.japisoft.editix.editor.xsd.view2.nodeview;

import java.awt.Color;
import java.awt.Graphics2D;

import javax.swing.ImageIcon;

import com.japisoft.editix.editor.xsd.view.View;
import com.japisoft.editix.editor.xsd.view2.node.XSDNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ImageXSDNodeView extends AbstractXSDNodeView {
	
	private String urlImage;
	
	public ImageXSDNodeView( XSDNode node, String urlImage ) {
		super( node );
		this.urlImage = urlImage;
		hpadding = 10;
		vpadding = 8;
	}
	
	@Override
	protected void createBuffer(View designer) {
		ImageIcon ii = new ImageIcon(
			getClass().getResource( urlImage )
		);
		buffer = createBufferedImage( 
			ii.getIconWidth(), 
			ii.getIconHeight() 
		);
		Graphics2D g2d = ( Graphics2D )buffer.getGraphics();
		
		if ( !node.isEnabled() || node.isReference() ) {
			g2d.setColor( DISABLED_COLOR );
		} else		
		if ( node.isSelected() ) {
			g2d.setColor( getSelectionColor() );
		} else {		
			g2d.setColor( getEnabledColor() );
		}

		g2d.fillRoundRect( 0, 0, buffer.getWidth(), buffer.getHeight(), 10, 10 );
		g2d.setColor( Color.BLACK );
		
		g2d.drawImage( 
			ii.getImage(), 
			hpadding, 
			vpadding, 
			null 
		);
		
		setBorder( g2d );
		g2d.setColor( BORDER_COLOR );
		g2d.drawRoundRect( 0, 0, buffer.getWidth() - 1, buffer.getHeight() - 1, 10, 10 );
		
	}

}
