package com.japisoft.editix.editor.xsd.view2.nodeview;

import com.japisoft.editix.editor.xsd.view2.node.XSDNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSDNodeViewFactory {

	private static XSDNodeViewFactory instance = null;

	private XSDNodeViewFactory() {
		instance = this;
	}

	public static XSDNodeViewFactory getInstance() {
		if ( instance == null )
			new XSDNodeViewFactory();
		return instance;
	}

	public XSDNodeView getView( XSDNode node ) {
		if ( node.match( "attribute" ) ) {
			return new AttributeNodeView( node );
		} else
		if ( node.match( "sequence" ) ) {
			return new SequenceXSDNodeView( node );
		} else
		if ( node.match( "all" ) ) {
			return new SequenceXSDNodeView( node );
		} else
		if ( node.match( "choice" ) ) {
			return new ChoiceXSDNodeView3( node );
		} else
		if ( node.match( "key" ) ) {
			return new KeyXSDNodeView( node );
		} else
		if ( node.match( "keyref" ) ) {
			return new KeyRefXSDNodeView2( node );
		}
		return new AbstractXSDNodeView( node );
	}
	
}
