package com.japisoft.editix.filedragging;

import java.io.File;
import java.util.List;

import com.japisoft.xmlpad.XMLDocumentInfo;
import com.japisoft.xmlpad.editor.XMLEditor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CSSFileDragging extends DefaultFileDragging {

	public void drag(XMLEditor editor, List<File> files) {
		XMLDocumentInfo info = editor.getXMLContainer().getDocumentInfo();
		if ( "CSS".equals( info.getType() ) ) {
			for ( File f : files ) {
				if ( "css".equals( getFileExt( f ) ) ) {
					editor.insertText( "@import url(\"" );
					if ( sameParent(f, editor ) ) {
						editor.insertText( f.getName() );
					} else {
						editor.insertText( f.toURI().toString() );
					}
					editor.insertText( "\")" );
				}
			}
		} else
		if ( "HTML".equals( info.getType() ) || "XHTML".equals( info.getType() ) ) {
			for ( File f : files ) {
				if ( "css".equals( getFileExt( f ) ) ) {
					editor.insertText( "<link rel=\"stylesheet\" type=\"text/css\" href=\"" );
					if ( sameParent( f, editor ) ) {
						editor.insertText( f.getName() );
					} else
						editor.insertText( f.toURI().toString() );
					if ( "XHTML".equals( info.getType() ) ) {
						editor.insertText( "/" );
					}
					editor.insertText( "\">" );
				}
			}
		} else
		super.drag( editor, files );
	}
	
}
