package com.japisoft.editix.main.steps;

import java.io.StringReader;

import com.japisoft.framework.ApplicationStepAdapter;
import com.japisoft.xmlpad.tree.parser.XMLParserFactory;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class InitParserStep extends ApplicationStepAdapter {

	@Override
	public void start(String[] args) {
		super.start(args);
		try {
			XMLParserFactory.getInstance().newParser().parse( new StringReader( "<a/>"), null );
		} catch( Throwable th ) {
			System.err.println( "Can't parse a document with the default parser ?" );
			th.printStackTrace();
		}
	}
	
}
