package com.japisoft.editix.mapper;

import java.util.ArrayList;
import java.util.List;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;


/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public abstract class AbstractMapper implements Mapper {

	public List<MatchingResult> map(IXMLPanel panel, FPNode currentNode) {
		ArrayList<MatchingResult> result = new ArrayList<MatchingResult>();
		
		FPNode root = ( FPNode )currentNode.getDocument().getRoot();
		if ( panel instanceof XMLContainer ) {
			XMLContainer container = ( XMLContainer )panel;
		}
		
		walkInto(
			panel,
			currentNode,
			root, 
			result 
		);

		return result;
	}

	public String[] getMapAttributes() {
		return new String[] { getMapAttribute() };
	}

	protected String getMapAttribute() {
		return null;
	}
	
	protected void walkInto(
		IXMLPanel panel,
		FPNode sourceNode,
		FPNode walkingNode, 
		ArrayList<MatchingResult> result  ) {
		if ( isMatchingNode( sourceNode, walkingNode ) )
			result.add( new MatchingResult( panel, walkingNode ) );
		for ( int i = 0; i < walkingNode.childCount(); i++ ) {
			if ( walkingNode.getType() == FPNode.TAG_NODE )
				walkInto(
					panel,
					sourceNode,
					walkingNode.childAt( i ), 
					result 
				);
		}
	}

	protected boolean isMatchingNode( FPNode sourceNode, FPNode walkingNode ) {
		return false;
	}

}
