package com.japisoft.editix.ui;

import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JMenu;
import javax.swing.JRadioButtonMenuItem;

import com.japisoft.editix.action.file.EncodingAction;
import com.japisoft.framework.application.descriptor.helpers.MenuBuilderDelegate;
import com.japisoft.framework.preferences.Preferences;
import com.japisoft.framework.xml.Encoding;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EncodingMenuBuilder implements MenuBuilderDelegate {

	public void build( JMenu menu ) {
		menu.setEnabled( true );
		String[] encoding = Encoding.XML_ENCODINGS;
		ButtonGroup bg = new ButtonGroup();
		for ( int i = 0; i < encoding.length; i++ ) {
			EncodingAction action = new EncodingAction( encoding[ i ] );
			JRadioButtonMenuItem item = new JRadioButtonMenuItem( action );
			if ( encoding[ i ].equals( 
					Preferences.getPreference( "file", "rw-encoding", encoding )[ 0 ] ) )
				item.setSelected( true );
			bg.add( item );
			menu.add( item );
			if ( "DEFAULT".equals( item.getText() ) ) {
				String currentEncoding = System.getProperty( "file.encoding" );
				if ( currentEncoding == null )
					currentEncoding = "unknown";
				item.setText( "DEFAULT (" + currentEncoding + ")" );
			}
		}
	}

	public static JComboBox encodingComboBox() {
		JComboBox combo = new JComboBox();
		String[] encoding = Encoding.XML_ENCODINGS;
		for ( int i = 0; i < encoding.length; i++ ) {
			combo.addItem( encoding[ i ] );
		}

		String tmp = 
			Preferences.getPreference( "file", "rw-encoding", encoding )[ 0 ];

		if ( "DEFAULT".equals( tmp ) ) {
			String currentEncoding = System.getProperty( "file.encoding" );
			if ( currentEncoding == null )
				currentEncoding = "unknown";
			tmp = "DEFAULT (" + currentEncoding + ")"; 
		}

		combo.setSelectedItem( tmp );
		return combo;
	}

}
