package com.japisoft.editix.ui;

import java.awt.Window;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JFrame;

import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.dialog.register.RegisteredPane2;
import com.japisoft.p3.Manager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class RA extends AbstractAction {

	public void actionPerformed(ActionEvent e) {
		RegisteredPane2 rp2 = new RegisteredPane2();
		if ( DialogManager.showDialog(
			(Window)null, 
			"Register",
			"Register", 
			"You can order at http://www.editix.com/buy.html and receive instantly by mail your activating key. Copy and Paste your registered name and key or fill it from a file", 
			null, 
			rp2 
		) == DialogManager.OK_ID ) {
			String u = rp2.getUser();
			String p = rp2.getKey();
			
			try {
				boolean ok = Manager.registered( u, p );
				if ( ok ) {
					EditixFactory.buildAndShowInformationDialog( "Registered EditiX is now activated. Please restart the application" );
				} else {
					EditixFactory.buildAndShowErrorDialog( "Wrong name or key, please check for your registered name and key (remove extra spaces...)\nNote that a 2008 key is only for a 2008 version, a 2009 key is only for a 2009 version, etc...\n\nYour current version is EditiX XML Editor " + EditixApplicationModel.getAppYear() + "\n\nIf you have non ASCII characters inside your registered name, it may be wrongly encoded, please contact us at : editixsupport@japisoft.com for generating a new key" );
				}
			} catch( Exception exc ) {
				if ( !"Extend evaluation".equals( exc.getMessage() ) )
					EditixFactory.buildAndShowErrorDialog( "Can't register : " + exc.getMessage() );
				else
					throw new RuntimeException( "Extend evaluation" );
			}			
		}
		
		/*
		RegisteredDialog dialog = new RegisteredDialog();
		dialog.setSize( 400, 460 );
		dialog.setVisible( true );
		if ( dialog.isOk() ) {
			String u = dialog.getUser();
			String p = dialog.getKey();
			
			try {
				boolean ok = Manager.registered( u, p );
				if ( ok ) {
					EditixFactory.buildAndShowInformationDialog( "Registered EditiX is now activated. Please restart the application" );
				} else {
					EditixFactory.buildAndShowErrorDialog( "Wrong name or key, please check for your registered name and key (remove extra spaces...)\nNote that a 2008 key is only for a 2008 version, a 2009 key is only for a 2009 version, etc...\n\nYour current version is EditiX XML Editor " + EditixApplicationModel.getAppYear() + "\n\nIf you have non ASCII characters inside your registered name, it may be wrongly encoded, please contact us at : editixsupport@japisoft.com for generating a new key" );
				}
			} catch( Exception exc ) {
				if ( !"Extend evaluation".equals( exc.getMessage() ) )
					EditixFactory.buildAndShowErrorDialog( "Can't register : " + exc.getMessage() );
				else
					throw new RuntimeException( "Extend evaluation" );
			}
		} */
	}

}
	
