package com.japisoft.editix.ui;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JRadioButtonMenuItem;

import com.japisoft.framework.application.descriptor.helpers.MenuBuilderDelegate;
import com.japisoft.framework.preferences.Preferences;
import com.japisoft.framework.xml.Encoding;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XMLSpaceBuilder implements MenuBuilderDelegate {

	public void build(JMenu menu) {
		
		menu.setEnabled( true );		
		ChangeXMLSpaceAction action = new ChangeXMLSpaceAction();
		JCheckBoxMenuItem item = new JCheckBoxMenuItem( action );				
		item.setSelected( Preferences.getPreference( "xmlconfig", "format-xml:space", true ) );

		menu.add( item );

	}

	class ChangeXMLSpaceAction extends AbstractAction {
		
		ChangeXMLSpaceAction() {
			putValue( Action.NAME, "automatic" );
		}
		public void actionPerformed(ActionEvent e) {
			Preferences.setPreference( "xmlconfig", "format-xml:space", ( ( JCheckBoxMenuItem )e.getSource() ).isSelected() );
			EditixFactory.buildAndShowInformationDialog( "Please restart EditiX for applying" );
		}
	}

}
