package com.japisoft.editix.ui.container.locationbar;

import java.awt.Color;

import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSLTLabel implements Label {

	Color c = new Color( 200, 220, 200 );
	
	public Color getColor(FPNode node) {
		if ( node.matchContent( "template" ) )
			return c;
		if ( node.matchContent( "for-each" ) )
			return c;
		if ( node.matchContent( "variable" ) )
			return c;
		return null;
	}

	public String getLabel(FPNode node) {
		if ( node.matchContent( "variable" ) ) {
			String tmp = node.getNodeContent() + "[";
			tmp += node.getAttribute( "name" );
			tmp += "]";
			return tmp;			
		} else
		if ( node.matchContent( "template" ) ) {
			String tmp = node.getNodeContent() + "[";
			if ( node.hasAttribute( "name" ) )
				tmp += node.getAttribute( "name" );
			if ( node.hasAttribute( "match" ) )
				tmp += node.getAttribute( "match" );
			tmp += "]";
			return tmp;
		} else
		if ( node.matchContent( "for-each" ) ) {
			String tmp = node.getNodeContent() + "[";
			tmp += node.getAttribute( "select" );
			tmp += "]";
			return tmp;			
		}
		return null;
	}

}
