package com.japisoft.editix.ui.container.xpath;

import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XPathRunnerResultObject {

	private Node sourceNode;
	private Node xpathResultNode;
	private XPathExpression xpathEngine;
	private String value;

	public XPathRunnerResultObject( 
			Node sourceNode, 
			XPathExpression xe ) {
		this.sourceNode = sourceNode;
		this.xpathEngine = xe;
	}

	public Node getSourceNode() {
		return sourceNode;
	}

	public String getValue() {
		if ( value == null ) {
			try {
				xpathResultNode = ( Node )xpathEngine.evaluate( 
						sourceNode, 
						XPathConstants.NODE 
				);
				if ( xpathResultNode != null ) {
					value = xpathResultNode.getNodeValue();
				}
			} catch( Exception exc ) {
				value = "XPath Error";
			}
		}
		return value;
	}

	public void setValue( String value ) {
		if ( xpathResultNode != null ) {
			xpathResultNode.setNodeValue( value );
			this.value = value;
		} else {
			if ( sourceNode instanceof Element ) {
				sourceNode.appendChild( sourceNode.getOwnerDocument().createTextNode( value ) );
			}
		}
	}

}
