package com.japisoft.editix.ui.panels.project2;

import java.io.File;

import javax.swing.JComponent;

import com.japisoft.editix.ui.panels.AbstractPanel;
import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ProjectPanel extends AbstractPanel {

	@Override
	protected JComponent buildView() {
		return new ProjectUI();
	}

	@Override
	protected String getTitle() {
		return "Project";
	}
	
	@Override
	protected String getId() {
		return "project2";
	}

	public void loadProject( File file ) {
		if ( file == null ) {
			hide();
		} else {
			Project project = ProjectManager.getInstance().loadProject( file );
			try {
				project.load();
			} catch( Exception exc ) {
				ApplicationModel.debug( exc );
			}
			( ( ProjectUI )getView() ).setProject( project );
			show();
			setState( true );
		}
	}
	
	public void stop() {
		try {
			( ( ProjectUI )getView() ).save();
		} catch( Exception e ) {
			ApplicationModel.debug( e );
		}
	}
	
	@Override
	protected void preHide() {
		stop();
	}

}
