package com.japisoft.editix.ui.panels.project2.synchro;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.dialog.DialogManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SynchroChoosePanel extends JPanel implements ActionListener {

	private int initSelection;
	
    /** Creates new form SynchroPanel */
    public SynchroChoosePanel( Synchronizer[] synchronizers, int selection ) {
        initComponents();
        if ( synchronizers != null ) {
        	for ( Synchronizer s : synchronizers ) {
        		cbConfig.addItem( s );
        	}
        }
        initSelection = selection;
    }

    @Override
    public void addNotify() {
    	super.addNotify();
    	btDelete.addActionListener( this );
    	btNewConfig.addActionListener( this );
    	if ( initSelection > -1 && cbConfig.getItemCount() > 0 ) {
    		cbConfig.setSelectedIndex( initSelection );
    	}
    }

    @Override
    public void removeNotify() {
    	super.removeNotify();
    	btDelete.removeActionListener( this );
    	btNewConfig.removeActionListener( this );    	
    }
    
    public Synchronizer[] getSynchronizers() {
    	Synchronizer[] t = new Synchronizer[ cbConfig.getItemCount() ];
    	for ( int i = 0; i< cbConfig.getItemCount(); i++ ) {
    		t[ i ] = ( Synchronizer )cbConfig.getItemAt( i );
    	}
    	return t;
    }
    
    public Synchronizer getSelectedSynchronizer() {
    	return ( Synchronizer )cbConfig.getSelectedItem();
    }
    
    public void actionPerformed(ActionEvent e) {
    	if ( e.getSource() == btDelete ) {
    		if ( cbConfig.getSelectedItem() != null )
    			cbConfig.removeItem( 
    				cbConfig.getSelectedItem() 
    			);
    	} else 
    	if ( e.getSource() == btNewConfig ) {
    		SynchroConfigPanel scp = new SynchroConfigPanel();
    		if ( DialogManager.showDialog( 
    			ApplicationModel.MAIN_FRAME, 
    			"Configuration", 
    			"Configuration", 
    			"Configuration a server", 
    			null, 
    			scp ) == DialogManager.OK_ID ) {
    			Synchronizer s = scp.getSynchronizer();
    			if ( s != null ) {
    				cbConfig.addItem( s );
    				cbConfig.setSelectedItem( s );
    			}
    		}
    	}
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        cbConfig = new javax.swing.JComboBox();
        btNewConfig = new javax.swing.JButton();
        btDelete = new javax.swing.JButton();

        jLabel1.setText("Source");
        jLabel1.setName("jLabel1"); // NOI18N

        cbConfig.setName("cbConfig"); // NOI18N

        btNewConfig.setText("New source...");
        btNewConfig.setName("btNewConfig"); // NOI18N

        btDelete.setText("Delete");
        btDelete.setName("btDelete"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btNewConfig)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btDelete))
                    .addComponent(cbConfig, 0, 383, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(cbConfig, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btNewConfig)
                    .addComponent(btDelete))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>


    // Variables declaration - do not modify
    private javax.swing.JButton btDelete;
    private javax.swing.JButton btNewConfig;
    private javax.swing.JComboBox cbConfig;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration

}
