package com.japisoft.editix.ui.panels.project2.synchro;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SynchronizerFactory {

	private static SynchronizerFactory INSTANCE = null;
	
	private SynchronizerFactory() {
		INSTANCE = this;
	}
	
	public static SynchronizerFactory getInstance() {
		if ( INSTANCE == null ) {
			new SynchronizerFactory();
		}
		return INSTANCE;
	}

	public Synchronizer getSynchronizer( String name ) {
		if ( "LOCAL/NETWORK".equalsIgnoreCase( name ) )
			return new FileSynchronizer();
		else
		if ( "ftp".equalsIgnoreCase( name ) )
			return new FTPSynchronizer();
		return null;
	}

	public String[] getTypes() {
		return new String[] { "LOCAL/NETWORK", "FTP" };
	}

}
