package com.japisoft.editix.ui.panels.xpath;

import javax.swing.JComponent;

import com.japisoft.editix.ui.panels.AbstractPanel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XPathPanel extends AbstractPanel {

	protected JComponent buildView() {
		return new XPathUI();
	}

	protected String getTitle() {
		return "XPath";
	}

	public void stop() {
	}

	@Override
	protected void preShow() {
//		if ( !isShown() ) {
			// Run directly XPath expression
			if ( params != null ) {
				runXPath( params );
			}
//		}
		super.preShow();
	}

	@Override
	public void setParams( String params ) {
		super.setParams( params );
		
		if ( params != null && !"".equals( params ) )
			runXPath( params );
		
		
//		if ( isVisible() ) {
//			runXPath( params );
//		}
	}

	private void runXPath( String xpath ) {
		( ( XPathUI )getView() ).setXPath( xpath, 1 );
		( ( XPathUI )getView() ).runFromRoot();
	}

}
