package com.japisoft.editix.ui.xslt;

import java.awt.BorderLayout;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.BadLocationException;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSLTConsolePanel extends JPanel {

	private JTextArea ta = null;
	
	public XSLTConsolePanel() {
		setLayout( new BorderLayout() );
		add( new JScrollPane( ta = new JTextArea() ) );
		ta.setEditable( false );
	}

	public void setMessage( String msg ) {
		ta.setText( msg );
	}
	
	private PrintStream currentStream = null;
	private PrintStream currentStreamErr = null;	
	
	public void setEnabledConsole( boolean enabled ) {
		if ( enabled ) {
			ta.setText( "" );
			currentStream = System.out;
			currentStreamErr = System.err;
			PrintStream po = new PrintStream( new CustomOut() );
			System.setOut( po );
			System.setErr( po );
		} else {
			if ( currentStream != null ) {
				System.out.flush();
				System.err.flush();
				System.setOut( currentStream );
				System.setErr( currentStreamErr );
			}
		}		
	}

	class CustomOut extends OutputStream {
		
		@Override
		public void write(int b) throws IOException {
			int length = ta.getDocument().getLength();
			try {
				ta.getDocument().insertString( length, Character.toString( (char)b ), null );
			} catch( BadLocationException bex ) {
			}
		}

	}
	
}

