package com.japisoft.editix.update;

import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CheckJVMVersion {

	public static String check() {

		String version = System.getProperty( "java.vm.version" );
		
		if ( version != null ) {
			if ( version.startsWith( "1.1" ) ) {
				return "You current Java version is too old (1.1). " + getRequireMessage();
			} else
			if ( version.startsWith( "1.2" ) ) {
				return "You current Java version is too old (1.2). " + getRequireMessage();
			} else
			if ( version.startsWith( "1.3" ) ) {
				return "You current Java version is too old (1.3). " + getRequireMessage();
			} else
			if ( version.startsWith( "1.4" ) ) {
				return "You current Java version is too old (1.4). " + getRequireMessage();
			} else
			if ( version.startsWith( "1.5" ) ) {
				return "You current Java version is too old (1.5). " + getRequireMessage();
			} else
			if ( version.startsWith( "1.6" ) ) {
				return "You current Java version is too old (1.6). " + getRequireMessage();
			} else
			if ( version.startsWith( "1.7" ) ) {
				return "You current Java version is too old (1.7). " + getRequireMessage();
			}

		} 

		return null;
	}

	private static String getRequireMessage() {
		String require = "EditiX requires at least a Java 8 version\nPlease download it at ";
		if ( ApplicationModel.isMacOSXPlatform() ) {
			require += "http://developer.apple.com/java/";
		} else
			require += "http://www.javasoft.com";
		return require;
	}
	
}
