
package com.japisoft.editix.update;

import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.preferences.Preferences;
import com.japisoft.framework.ui.toolkit.BrowserCaller;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class UpdateManager {

		static {

			if ( EditixApplicationModel.MAJOR_VERSION == 6 ) {
				if ( "false".equals( Preferences.getPreference( "system", "update6.1", "false" ) ) ) {
					System.out.println( "Update default browser" );
					if ( !ApplicationModel.isOtherPlatform() ) {
						Preferences.getPreference( "viewer", "html", "firefox" );
					}
					Preferences.setPreference( "system", "update6.1", "true" );
				}
			}

			if ( EditixApplicationModel.MAJOR_VERSION == 6 ) {
				
				if ( "false".equals( Preferences.getPreference( "system", "update6.2", "false" ) ) ) {
					System.out.println( "Update default browser" );

					if ( ApplicationModel.isWindowsPlatform() ) {
						Preferences.setPreference( "viewer", "html", BrowserCaller.WIN_PATH + " " + BrowserCaller.WIN_FLAG  );
					} else
					if ( ApplicationModel.isMacOSXPlatform() ) {
						Preferences.setPreference( "viewer", "html", BrowserCaller.MAC_PATH );
					} else
					if ( ApplicationModel.isOtherPlatform() ) {
						Preferences.setPreference( "viewer", "html", BrowserCaller.UNIX_PATH );						
					}

					Preferences.setPreference( "system", "update6.2", "true" );
				}

			}			
		}

		static void updateForANewVersion( int major, int minor ) {
			// Remove all dialogs location
			Preferences.removeAllPreferencesForType( Preferences.RECTANGLE );
			EditixApplicationModel.debug( "Update for release " + major + " . " + minor );
			
			if ( major > 5 || ( major == 5 && minor >= 1 ) ) {
				Preferences.removePreference( "xslt", "parameter" );
			}			
		}

}
