package com.japisoft.framework.css;

import java.awt.Color;
import java.util.HashMap;
import java.util.Map;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CSSBorder {

	private CSSDim width;
	private String style;
	private Color color;

	public CSSDim getWidth() {
		return width;
	}
	public void setWidth(CSSDim width) {
		this.width = width;
	}
	public String getStyle() {
		return style;
	}
	public void setStyle(String style) {
		this.style = style;
	}
	public Color getColor() {
		return color;
	}
	public void setColor(Color color) {
		this.color = color;
	}

	public boolean isInvisible() {
		return this.style == null || 
			"none".equalsIgnoreCase( this.style ) || 
					"hidden".equalsIgnoreCase( this.style );
	}

	public void merge( CSSBorder border ) {
		if ( border.width != null )
			this.width = border.width;
		if ( border.style != null )
			this.style = border.style;
		if ( border.color != null )
			this.color = border.color;
	}

	private Map<String,CSSBorder> sides = null;

	/**
	 * @param side border-left, border-right, border-top, border-bottom
	 * @param border
	 */
	public void setSide( String side, CSSBorder border ) {
		if ( sides == null )
			sides = new HashMap<String, CSSBorder>();
		sides.put( side, border );
	}
	
	public CSSBorder getSide( String side ) {
		if ( sides == null )
			return this;
		CSSBorder border = sides.get( side );
		if ( border == null )
			return this;
		return border;
	}
	
	@Override
	public String toString() {
		return this.style + " " + this.width + " " + this.color;
	}
	
}
