package com.japisoft.framework.desktop;

import java.awt.Desktop;
import java.io.File;
import java.io.IOException;
import java.net.URI;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SystemDesktop {

	public static void openExplorer( File f ) throws IOException {
		if ( f.isFile() )
			f = f.getParentFile();
		Desktop desktop = Desktop.getDesktop();
		if ( desktop != null )
			desktop.open( f );
	}
	
	public static void openBrowser( URI uri ) throws IOException {
		Desktop desktop = Desktop.getDesktop();
		if ( desktop != null ) {
			desktop.browse( uri );
		}
	}
	
}
