package com.japisoft.framework.dialog;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;

import javax.swing.BoxLayout;

import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;

import com.japisoft.framework.ui.UnderlinedLabel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class HeaderPanel extends JComponent {

	private HeaderPanel() {
		if ( UIManager.getColor( "com.japisoft.framework.dialog.titlebg" ) == null )
			UIManager.put( "com.japisoft.framework.dialog.titlebg", Color.WHITE );
		if ( UIManager.getFont( "com.japisoft.framework.dialog.font" ) == null )
			UIManager.put( "com.japisoft.framework.dialog.font", new Font("dialog", Font.PLAIN, 10)  );
		if ( UIManager.getIcon( "com.japisoft.framework.dialog.icon" ) == null )
			UIManager.put( "com.japisoft.framework.dialog.icon", new ImageIcon( getClass().getResource( "gear.png" ) ) );	
	}

	public HeaderPanel( String title, String description ) {
		this();

		setBackground( UIManager.getColor( "com.japisoft.framework.dialog.titlebg" ) );

		JPanel p = new JPanel();
		p.setBackground( getBackground() );
		p.setLayout(new BoxLayout( p, BoxLayout.Y_AXIS) );

		UnderlinedLabel lblTitle = new UnderlinedLabel( title );

		JTextArea txtComment = new JTextArea( description );
		txtComment.setBorder( new EmptyBorder( 5, 5, 5, 5 ) );
		txtComment.setWrapStyleWord(true);
		txtComment.setEditable(false);
		txtComment.setFont( UIManager.getFont( "com.japisoft.framework.dialog.font"  ) );

		JLabel l;
			l = new JLabel( UIManager.getIcon( "com.japisoft.framework.dialog.icon" ) );
		l.setOpaque( true );
		l.setBackground( getBackground() );

		JPanel p2  = new JPanel( new BorderLayout() );
		p2.setBackground( getBackground() );
		p2.add( lblTitle );

		p.add( p2 );
		p.add( txtComment );

		setLayout( new BorderLayout() );
		add( p, BorderLayout.CENTER );
		add( l, BorderLayout.EAST );
		
		setBorder( new EtchedBorder( Color.WHITE, Color.LIGHT_GRAY ) );		
	}

}
