package com.japisoft.framework.dialog.basic;

import java.awt.Container;
import java.awt.Dialog;
import java.awt.Font;

import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.japisoft.framework.dialog.BasicOKCancelDialogComponent;
import com.japisoft.framework.ui.TitleLabel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FontDialog extends BasicOKCancelDialogComponent {

	public FontDialog( Dialog owner, Font init ) {
		super( owner, "Font", "Font choice", "Choose your font", null );
		initUI();
		setValue( init );
	}

	private JTextField tfName;
	private JComboBox cbStyle = new JComboBox(
		new Object[] {
			"PLAIN",
			"BOLD",
			"ITALIC"
		} );

	private JComboBox cbSize = new JComboBox(
		new Object[] {
			"10",
			"11",
			"12",
			"13",
			"14",
			"15",
			"16",
			"17",
			"18",
			"20"
		} );
	
	private void initUI() {
		Container container = new JPanel();
		container.setLayout( new BoxLayout( container, BoxLayout.Y_AXIS ) );
		container.add( new TitleLabel( "Font name" ) );
		container.add( tfName = new JTextField() );
		container.add( new TitleLabel( "Font style" ) );
		container.add( cbStyle );
		container.add( new TitleLabel( "Font size" ) );
		container.add( cbSize );
		setUI( (JComponent)container );
	}

	public void setValue( Font font ) {
		tfName.setText( font.getName() );
		if ( font.getStyle() == Font.PLAIN ) {
			cbStyle.setSelectedIndex( 0 );			
		} else
		if ( font.getStyle() == Font.BOLD ) {
			cbStyle.setSelectedIndex( 1 );
		} else
		if ( font.getStyle() == Font.ITALIC ) {
			cbStyle.setSelectedIndex( 2 );
		}
		cbSize.setSelectedIndex( font.getSize() - 10 );
	}

	public Font getValue() {
		String _ = tfName.getText();
		if ( "".equals( _ ) )
			_ = "dialog";

		return 
			new Font( 
				_,
				cbStyle.getSelectedIndex(),
				cbSize.getSelectedIndex() + 10 );
	}

}
