package com.japisoft.framework.dialog.report;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.dialog.DialogManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ReportingListAction extends AbstractAction {

	private String url;
	
	public ReportingListAction( String url ) {
		super();
		this.url = url;
	}

	public String comment = "Bugs and suggests list.\nThis is the result of your bugs reporting and feature requests"; 
	
	public void actionPerformed( ActionEvent e ) {
		DialogManager.showDialog(
				ApplicationModel.MAIN_FRAME,
				"Reporting list",
				"User reports",
				comment,
				null,
				new ReportingListPanel( url ),
				null,
				new Dimension( 500, 400 ) );		
	}	

}
