package com.japisoft.framework.dockable;

import java.awt.Color;
import java.awt.Rectangle;

import javax.swing.Icon;
import javax.swing.JComponent;

import com.japisoft.framework.dockable.action.ActionModel;
import com.japisoft.framework.dockable.action.BasicActionModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class ComponentIdable implements Windowable {

	private JComponent comp;

	public ComponentIdable( JComponent comp ) {
		this.comp = comp;
		if ( comp == null )
			throw new RuntimeException( "No component provided !" );
	}

	public String getId() {
		return comp.getName();
	}

	public JComponent getView() {
		return (JComponent)comp;
	}

	public JComponent getUserView() {
		return getView();
	}	
	
	public String getTitle() {
		return null;
	}	
	
	public void setTitle(String title) {
	}
	
	public	ActionModel getActionModel() {
		return new BasicActionModel();
	}
	
	public void setBackground( Color background ) {
		comp.setBackground( background );
	}
	
	public void setForeground( Color foreground ) {
		comp.setForeground( foreground );
	}

	public void requestFocus() {
		comp.requestFocus();
	}
	
	public JComponent getContentPane() {
		throw new RuntimeException( "Illegal usage" );
	}

	public void setContentPane( JComponent container ) {
		throw new RuntimeException( "Illegal usage" );		
	}	

	public void repaint() {
		comp.repaint();
	}

	public Rectangle getFrameBounds() {
		throw new RuntimeException( "Illegal usage" );
	}

	public void setFrameBounds( Rectangle r ) {
		throw new RuntimeException( "Illegal usage" );		
	}

	private boolean mstate = false;
	
	public void setMaximized(boolean max) {
		this.mstate = max;
	}
	
	public boolean isMaximized() {
		return mstate;
	}
	
	public Icon getIcon() {
		return null;
	}

	public void setIcon( Icon icon ) {
	}

	private boolean fixed = false;
		
	public boolean isFixed() {
		return fixed;
	}

	public void setFixed( boolean fixed ) {
		this.fixed = fixed;
	}	

	private boolean resize = true;
	
	public boolean isResizable() {
		return resize;
	}
	public void setResizable(boolean resize) {
		this.resize = resize;
	}

	public void fireDockEvent( String id, int type ) {
	}

}

