package com.japisoft.framework.spreadsheet;

import java.io.File;
import java.util.Map;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SpreadsheetFactory {

	private static SpreadsheetFactory INSTANCE = null;
	private Map<String,Spreadsheet> model = null;

	private SpreadsheetFactory() {
	}

	public static SpreadsheetFactory getInstance() {
		if ( INSTANCE == null )
			INSTANCE = new SpreadsheetFactory();
		return INSTANCE;
	}

	public Spreadsheet getSpreadsheet( File fileName ) throws Exception {
		String lastPart = fileName.getName().toLowerCase();
		int i = lastPart.lastIndexOf( "." );
		if ( i > -1 ) {
			String ext = lastPart.substring( i + 1 );
			
			if ( "csv".equals( ext ) )
				return new CsvSpreadsheet();
			else
			if ( "xls".equals( ext ) )
				return new XlsSpreadsheet();
			else
			if ( "xlsx".equals( ext ) )
				return new XlsxSpreadsheet();
			else
				throw new Exception( "Unknown file format" );			
		} else {
			throw new Exception( "Unknown file format" );
		}
	}

}
