package com.japisoft.framework.spreadsheet2;

import com.japisoft.framework.spreadsheet2.SpreadSheet;
import com.japisoft.framework.spreadsheet2.SpreadSheetConf;
import com.japisoft.framework.spreadsheet2.SpreadSheetFactory;
import com.japisoft.framework.spreadsheet2.csv.CSVSpreadSheet;
import com.japisoft.framework.spreadsheet2.txt.TXTSpreadSheet;
import com.japisoft.framework.spreadsheet2.xls.XLSSpreadSheet;
import com.japisoft.framework.toolkit.FileToolkit;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SpreadSheetFactory {

	private static SpreadSheetFactory factory = null;
	
	private SpreadSheetFactory() {
		super();
	}
	
	public static SpreadSheetFactory instance() {
		if ( factory == null )
			factory = new SpreadSheetFactory();
		return factory;
	}
	
	public SpreadSheet getSpreadSheet( SpreadSheetConf conf, String f ) throws Exception {
		
		if ( FileToolkit.matchExt( f, "csv" ) )
			return new CSVSpreadSheet( conf, f );
		if ( FileToolkit.matchExt( f, "xls" ) || FileToolkit.matchExt( f, "xlsx" ) )
			return new XLSSpreadSheet( conf, f );
		return new TXTSpreadSheet( conf, f );
	}
	
}
