package com.japisoft.framework.ui;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class LinkLabel extends FastLabel implements MouseListener {

	public LinkLabel( String label ) {
		super();
		setText( label );
		setForeground( new java.awt.Color(51, 51, 255) );
	}
	
	public LinkLabel() {
		setForeground( new java.awt.Color(51, 51, 255) );
	}
	
	public void addNotify() {
		super.addNotify();
		addMouseListener( this );
	}

	public void removeNotify() {
		super.removeNotify();
		removeMouseListener( this );
	}
		
	public void mouseEntered(MouseEvent e) {
		setUnderlineMode( true );
	}

	public void mouseClicked(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
		setUnderlineMode( false );
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

}
