package com.japisoft.framework.ui;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;

import javax.swing.JLabel;
import javax.swing.border.EmptyBorder;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class UnderlinedLabel extends JLabel {

	private int fh = 0;

	public UnderlinedLabel( String text ) {
		this();
		setText( text );
	}

	public UnderlinedLabel() {
		Font f = getFont();
		setFont( new Font( f.getName(), Font.BOLD, f.getSize() + 2 ) );
		FontMetrics fm = getFontMetrics( getFont() );
		fh = fm.getHeight();
		setBorder( new EmptyBorder( 0, 5, 0, 5 ) );
		setOpaque( false );
	}

	public void paintComponent( Graphics gc ) {
		super.paintComponent( gc );
		gc.setColor( Color.LIGHT_GRAY );
		int w = getWidth();
		gc.drawLine( 5, getHeight() - 2, w - 10, getHeight() - 2 );
		//gc.drawLine( 5, getHeight() - 1, w - 10, getHeight() - 1 );
	}

}
