package com.japisoft.framework.xml.dtd.instance;

import java.io.StringReader;

import com.japisoft.dtdparser.DTDParser;
import com.japisoft.dtdparser.node.RootDTDNode;
import com.japisoft.framework.xml.XMLFileData;
import com.japisoft.framework.xml.XMLToolkit;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DTDInstanceGenerator {

	public static String generateXMLInstance( String rootElement, String dtdURI, String dtdContent ) throws Throwable {

		XMLFileData data = null;
		if ( dtdContent == null )
			data = XMLToolkit.getContentFromURI( dtdURI, null );
		else
			data = new XMLFileData( null, dtdContent );
		DTDParser parser = new DTDParser();
		parser.parse( new StringReader( data.getContent() ) );
		RootDTDNode node = parser.getDTDElement();
		StringBuffer res = new StringBuffer();
		DTDBuildInstance dbi = new DTDBuildInstance();
		dbi.buildElement( res, rootElement, node );
		return res.toString();

	}

}
