package com.japisoft.framework.xml.refactor.elements;

import java.util.StringTokenizer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RefactorAction {

	private String action, oldValue, newValue;

	public RefactorAction( String compactDesc ) {
		StringTokenizer st = new StringTokenizer( compactDesc, ";;", false );
		setAction( st.nextToken() );
		setOldValue( st.nextToken() );
		if ( st.hasMoreTokens() )
			setNewValue( st.nextToken() );
	}

	public RefactorAction( String action, String oldv, String newv ) {
		this.action = action;
		this.oldValue = oldv;
		this.newValue = newv;
	}

	public String getAction() {
		return action;
	}

	public void setAction(String action) {
		this.action = action;
	}

	public String getNewValue() {
		return newValue;
	}

	public boolean isNewValueEmpty() {
		return newValue == null || 
			"".equals( newValue );
	}

	public void setNewValue(String newValue) {
		this.newValue = newValue;
	}

	public String getOldValue() {
		return oldValue;
	}

	public void setOldValue(String oldValue) {
		this.oldValue = oldValue;
	}
	
	public boolean matchOldValue( String value ) {
		if ( value == null )
			return false;
		//if ( "*".equals( oldValue ) )
		//	return true;
		return value.equals( oldValue );
	}

	public boolean containsOldValue( String value ) {
		if ( value == null )
			return false;
		return value.contains( oldValue );
	}
	
	public boolean matchNewValue( String value ) {
		if ( value == null )
			return false;
		return value.equals( newValue );
	}
	
	public String toString() {
		if ( oldValue == null )
			oldValue = "";
		if ( newValue == null )
			newValue = "";
		return action + ";;" + oldValue + ";;" + newValue;
	}

}
