package com.japisoft.framework.xml.refactor2;

import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.ext.LexicalHandler;

import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class AbstractRefactor implements LexicalHandler, ContentHandler {
	private ContentHandler handler;
	protected String oldValue;
	protected String newValue;

	public void setOldValue( String oldValue ) {
		this.oldValue = oldValue;
	}
	
	public void setNewValue( String newValue ) {
		this.newValue = newValue;
	}
	
	public String getOldValue() { return oldValue; }
	public String getNewValue() { return newValue; }

	public String getErrorMessage() { return null; }
	
	public void setContentHandler( ContentHandler handler ) {
		this.handler = handler;
	}

	public boolean process( FPNode node ) {
		return false;
	}
	
	public String getTitle( FPNode node ) {
		return null;
	}
	
	public boolean requireNewValue() { 
		return true;
	}

	/////////////////////////////////////////////////////////////////
	
	public void startDTD(String name, String publicId, String systemId)
			throws SAXException {
		( ( LexicalHandler )handler ).startDTD(
				name,
				publicId,
				systemId );
	}

	public void endDTD() throws SAXException {
		( ( LexicalHandler )handler ).endDTD();
	}

	public void startEntity(String name) throws SAXException {
		( ( LexicalHandler )handler ).startEntity( name );
	}

	public void endEntity(String name) throws SAXException {
		( ( LexicalHandler )handler ).endEntity( name );	
	}

	public void startCDATA() throws SAXException {
		( ( LexicalHandler )handler ).startCDATA();	
	}

	public void endCDATA() throws SAXException {
		( ( LexicalHandler )handler ).endCDATA();			
	}

	public void comment(char[] ch, int start, int length) throws SAXException {
		( ( LexicalHandler )handler ).comment(
				ch, start, length );
	}

	public void setDocumentLocator(Locator locator) {
		handler.setDocumentLocator( locator );
	}

	public void startDocument() throws SAXException {
		handler.startDocument();
	}

	public void endDocument() throws SAXException {
		handler.endDocument();
	}

	public void startPrefixMapping(String prefix, String uri)
			throws SAXException {
		handler.startPrefixMapping( prefix, uri );
	}

	public void endPrefixMapping(String prefix) throws SAXException {
		handler.endPrefixMapping( prefix );
	}

	public void startElement(String uri, String localName, String qName,
			Attributes atts) throws SAXException {
		handler.startElement( uri, localName, qName, atts );
	}

	public void endElement(String uri, String localName, String qName)
			throws SAXException {
		handler.endElement( uri, localName, qName );
	}

	public void characters(char[] ch, int start, int length)
			throws SAXException {
		handler.characters( ch, start, length );
	}

	public void ignorableWhitespace(char[] ch, int start, int length)
			throws SAXException {
		handler.ignorableWhitespace( ch, start, length );
	}

	public void processingInstruction(String target, String data)
			throws SAXException {
		handler.processingInstruction( target, data );
	}

	public void skippedEntity(String name) throws SAXException {
		handler.skippedEntity( name );
	}

}
