package com.japisoft.framework.xml.refactor2.elements;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import com.japisoft.framework.xml.refactor2.AbstractRefactor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ConvertAttributesToElement extends AbstractRefactor {

	public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {

		String name = localName;
		if ( name == null ) {
			name = qName;
			int i = name.lastIndexOf( ":" );
			if ( i > -1 ) {
				name = name.substring( i + 1 );
			}
		}

		Attributes atts2 = atts;
		
		// Remove the attributes
		if ( name.equals( oldValue ) ) 
			atts = null;
		
		super.startElement(uri, localName, qName, atts);
		
		if ( atts2 != null && name.equals( oldValue ) ) {
			for ( int i = 0; i < atts2.getLength(); i++ ) {

				String n = atts2.getQName( i );
				String v = atts2.getValue( i );
				super.startElement(
						uri,
						n,
						n,
						null );
				super.characters(
						v.toCharArray(),
						0,
						v.length() );
				super.endElement(
						uri,
						n,
						n );				
			}
		}
	}
	
}
