package com.japisoft.sc;

import java.util.Hashtable;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public final class ScPredefinedToken {
  /** Support all numbers */
  public static final String NUMBER_ID = "_NUMBER_";
  public static final String NUMBER_TOKENS = "(0;1;2;3;4;5;6;7;8;9;.;,)";
  /** Support +,-,/,*,% operators */
  public static final String OPERATOR_ID = "_OPERATOR_";
  public static final String OPERATOR_TOKENS = "+:-:/:*:%";
  /** Support "litteral" */
  public static final String LITTERAL_ID = "_LITTERAL_";
  public static final String LITTERAL_TOKENS = "[\";\"{{\\}}]";

  /** Carriage return */
  public static final String RC_TOKEN = "_RC_";
  /** Double dot */
  public static final String DD_TOKEN = "_DD_";

  static Hashtable htTokens = new Hashtable();

  static {
    htTokens.put( NUMBER_ID, NUMBER_TOKENS );
    htTokens.put( OPERATOR_ID, OPERATOR_TOKENS );
    htTokens.put( LITTERAL_ID, LITTERAL_TOKENS );
  }

  public static void addPredefinedToken( String tokenId, String tokenValues ) {
    htTokens.put( tokenId, tokenValues );
  }

  public static void removePredefinedToken( String tokenId, String tokenValues ) {
    htTokens.remove( tokenId );
  }

  static String getPredefinedTokenValues( String tokenId ) {
    return (String)htTokens.get( tokenId );
  }

  /** Convert a token to a valid format*/
  public static String getValidToken( String item ) {
    if ( ":".equals( item ) )
      return DD_TOKEN;
    else
      if ( "\n".equals( item ) )
        return RC_TOKEN;
    return item;
  }

}
