package com.japisoft.xflows;

import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class LoggerModel {
	
	private boolean fileLogInfoEnabled = false;
	private boolean fileLogWarningEnabled = false;
	private boolean fileLogErrorEnabled = false;
	
	private boolean mailLogInfoEnabled = false;
	private boolean mailLogWarningEnabled = false;
	private boolean mailLogErrorEnabled = false;

	private String fileLogInfo = null;
	private String fileLogWarning = null;
	private String fileLogError = null;
	
	private String mailLogInfo = null;
	private String mailLogWarning = null;
	private String mailLogError = null;

	public String getFileLogError() {
		return fileLogError;
	}
	public void setFileLogError(String fileLogError) {
		this.fileLogError = fileLogError;
	}
	public boolean isFileLogErrorEnabled() {
		return fileLogErrorEnabled;
	}
	public void setFileLogErrorEnabled(boolean fileLogErrorEnabled) {
		this.fileLogErrorEnabled = fileLogErrorEnabled;
	}
	public String getFileLogInfo() {
		return fileLogInfo;
	}
	public void setFileLogInfo(String fileLogInfo) {
		this.fileLogInfo = fileLogInfo;
	}
	public boolean isFileLogInfoEnabled() {
		return fileLogInfoEnabled;
	}
	public void setFileLogInfoEnabled(boolean fileLogInfoEnabled) {
		this.fileLogInfoEnabled = fileLogInfoEnabled;
	}
	public String getFileLogWarning() {
		return fileLogWarning;
	}
	public void setFileLogWarning(String fileLogWarning) {
		this.fileLogWarning = fileLogWarning;
	}
	public boolean isFileLogWarningEnabled() {
		return fileLogWarningEnabled;
	}
	public void setFileLogWarningEnabled(boolean fileLogWarningEnabled) {
		this.fileLogWarningEnabled = fileLogWarningEnabled;
	}
	public String getMailLogError() {
		return mailLogError;
	}
	public void setMailLogError(String mailLogError) {
		this.mailLogError = mailLogError;
	}
	public boolean isMailLogErrorEnabled() {
		return mailLogErrorEnabled;
	}
	public void setMailLogErrorEnabled(boolean mailLogErrorEnabled) {
		this.mailLogErrorEnabled = mailLogErrorEnabled;
	}
	public String getMailLogInfo() {
		return mailLogInfo;
	}
	public void setMailLogInfo(String mailLogInfo) {
		this.mailLogInfo = mailLogInfo;
	}
	public boolean isMailLogInfoEnabled() {
		return mailLogInfoEnabled;
	}
	public void setMailLogInfoEnabled(boolean mailLogInfoEnabled) {
		this.mailLogInfoEnabled = mailLogInfoEnabled;
	}
	public String getMailLogWarning() {
		return mailLogWarning;
	}
	public void setMailLogWarning(String mailLogWarning) {
		this.mailLogWarning = mailLogWarning;
	}
	public boolean isMailLogWarningEnabled() {
		return mailLogWarningEnabled;
	}
	public void setMailLogWarningEnabled(boolean mailLogWarningEnabled) {
		this.mailLogWarningEnabled = mailLogWarningEnabled;
	}

	public FPNode toXML() {
		FPNode logger = new FPNode( FPNode.TAG_NODE, "logger" );
		FPNode fileLogger = new FPNode( FPNode.TAG_NODE, "file" );
		fileLogger.setAttribute( "info", isFileLogInfoEnabled() );
		fileLogger.setAttribute( "warning", isFileLogWarningEnabled() );
		fileLogger.setAttribute( "error", isFileLogErrorEnabled() );
		
		fileLogger.setAttribute( "pathInfo", getFileLogInfo() );
		fileLogger.setAttribute( "pathWarning", getFileLogWarning() );
		fileLogger.setAttribute( "pathError", getFileLogError() );

		logger.appendChild( fileLogger );
		FPNode mailLogger = new FPNode( FPNode.TAG_NODE, "mail" );
		mailLogger.setAttribute( "info", isMailLogInfoEnabled() );
		mailLogger.setAttribute( "warning", isMailLogWarningEnabled() );
		mailLogger.setAttribute( "error", isMailLogErrorEnabled() );
		
		mailLogger.setAttribute( "pathInfo", getMailLogInfo() );
		mailLogger.setAttribute( "pathWarning", getMailLogWarning() );
		mailLogger.setAttribute( "pathError", getMailLogError() );

		logger.appendChild( mailLogger );

		return logger;
	}

	public void updateFromXML( FPNode task ) {
		// Skip the logger node

		FPNode file = task.childAt( 0 );
		setFileLogInfoEnabled( "true".equals( file.getAttribute( "info" ) ) );
		setFileLogWarningEnabled( "true".equals( file.getAttribute( "warning" ) ) );
		setFileLogErrorEnabled( "true".equals( file.getAttribute( "error" ) ) );

		setFileLogInfo( file.getAttribute( "pathInfo" ) );
		setFileLogWarning( file.getAttribute( "pathWarning" ) );
		setFileLogError( file.getAttribute( "pathError" ) );

		FPNode mail = task.childAt( 1 );
		
		setMailLogInfoEnabled( "true".equals( mail.getAttribute( "info" ) ) );
		setMailLogWarningEnabled( "true".equals( mail.getAttribute( "warning" ) ) );
		setMailLogErrorEnabled( "true".equals( mail.getAttribute( "error" ) ) );

		setMailLogInfo( mail.getAttribute( "pathInfo" ) );
		setMailLogWarning( mail.getAttribute( "pathWarning" ) );
		setMailLogError( mail.getAttribute( "pathError" ) );		

	}
	
}
