package com.japisoft.xflows.task;

import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Task {

	private String name;
	private String type;
	private TaskParams params;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getType() {
		return type;
	}
	
	public void setType(String type) {
		this.type = type;
	}

	public TaskParams getParams() {
		if ( params == null )
			params = new TaskParams();
		return params;
	}

	public void setParams(TaskParams params) {
		this.params = params;
	}
	
	public FPNode toXML() {
		FPNode task = new FPNode( FPNode.TAG_NODE, "task" );
		task.setAttribute( "name", name );
		task.setAttribute( "type", type );
		if ( params != null ) {
			FPNode sn = params.toXML();
			if ( sn != null )
				task.appendChild( sn );
		}
		return task;
	}

	public void updateFromXML( FPNode task ) {
		setName( task.getAttribute( "name" ) );
		setType( task.getAttribute( "type" ) );
		if ( task.childCount() > 0 ) {
			params = new TaskParams();
			params.updateFromXML( task.childAt( 0 ) );
		}
	}

	public String toString() {
		return "[" + getName() + "," + getType() + "," + params + "]";
	}
	
}


