package com.japisoft.xflows.task.format;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;

import com.japisoft.framework.xml.refactor.Refactor;
import com.japisoft.xflows.task.TaskContext;
import com.japisoft.xflows.task.TaskRunner;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FileFormatRunner implements TaskRunner {

	public boolean run(TaskContext context) {

		File source = context.getCurrentSourceFile();
		Refactor r = new Refactor();
		try {
			String newDoc = r.format( source );
			String encoding = r.getXMLEncoding();
			OutputStreamWriter output = 
				new OutputStreamWriter(
						new FileOutputStream( context.getCurrentTargetFile() ),
						encoding );
			try {
				output.write( newDoc );
			} finally {
				output.close();
			}
			
		} catch (Exception e) {
			context.addError( "Can't format file " + source + " : " + e.getMessage() );
		}

		return false;
	}	
	
}
