package com.japisoft.xmlform.designer;

import java.io.File;

import org.apache.xerces.jaxp.DocumentBuilderImpl;
import org.apache.xerces.jaxp.SAXParserFactoryImpl;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.preferences.Preferences;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XmlFormModel extends ApplicationModel {

	static {
		Preferences.PREF_FILENAME = "pref-xf1.prop";
		XmlFormModel.LONG_APPNAME = "XML Form";
		XmlFormModel.SHORT_APPNAME = "xmlform";
		XmlFormModel.BUILD = "220908";
		XmlFormModel.BETA_VERSION = 0;
		XmlFormModel.MAJOR_VERSION = 1;
		XmlFormModel.MINOR_VERSION = 0;
		XmlFormModel.SUBMINOR_VERSION = 0;
		XmlFormModel.MAIN_SUPPORT_EMAIL = "jsupport@japisoft.com";
		XmlFormModel.REGISTERED_FILE = "xf1.reg";
		XmlFormModel.USERINTERFACE_FILE = "xfd.xml";	
		
		System.getProperty( 
				"javax.xml.parsers.DocumentBuilderFactory", 
				DocumentBuilderImpl.class.getName() );
		
		System.getProperty( 
				"javax.xml.parsers.SAXParserFactory",
				 SAXParserFactoryImpl.class.getName() );

	}

	// Loaded document
	public static String CURRENT_DOCUMENT = null;

	public static DesignerFrame getDesignerFrame() {
		if ( XmlFormModel.MAIN_FRAME instanceof DesignerFrame )
			return ( DesignerFrame )XmlFormModel.MAIN_FRAME;
		return null;
	}

	public static String CURRENT_SPELLCHECK = null;

}
