package com.japisoft.xmlform.designer.library;

import java.lang.reflect.Constructor;

import javax.swing.Icon;

import com.japisoft.xmlform.component.AbstractXMLFormComponent;
import com.japisoft.xmlform.component.ComponentContext;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ComponentDescriptor {

	private Icon icon = null;
	private String name = null;
	private String className = null; 

	public ComponentDescriptor( Icon icon, String name, String className ) {
		this.icon = icon;
		this.name = name;
		this.className = className;
	}

	public Icon getIcon() {
		return icon;
	}
	
	public String getName() {
		return name;
	}
	
	public AbstractXMLFormComponent create( 
			boolean designMode, 
			ComponentContext context ) throws Exception {

		Class cl = Class.forName( className );
		Constructor constructor = cl.getConstructor( boolean.class, ComponentContext.class );
		AbstractXMLFormComponent component = 
			( AbstractXMLFormComponent )constructor.newInstance( designMode, null );
		// For avoiding it to get the current grammar node
		component.setContext( context );
		component.setXpath( "Location" );
		return component;

	}

}
