package com.japisoft.xmlform.designer.properties.editors;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;

import javax.swing.JButton;

import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.xmlform.designer.properties.PropertyEditor;
import com.japisoft.xmlform.designer.properties.PropertyEditorListener;
import com.japisoft.xmlform.editor.EditorModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DictionnaryEditor 
		extends JButton implements 
			ActionListener, PropertyEditor {
	
	public DictionnaryEditor() {
		setText( "Dictionnary" );
	}

	@Override
	public void addNotify() {
		super.addNotify();
		addActionListener( this );
	}

	@Override
	public void removeNotify() {
		super.removeNotify();
		removeActionListener( this );
	}

	public Object getValue() {
		return value;
	}

	public Component getView() {
		return this;
	}

	private PropertyEditorListener listener;
	
	public void setPropertyEditorListener( PropertyEditorListener listener ) {
		this.listener = listener;
	}

	public void setSelected(boolean selected) {
	}

	private HashMap<String,String> value = null;
	
	public void setValue( Object value ) {
		this.value = ( HashMap )value;
	}

	public void actionPerformed(ActionEvent e) {
		DictionnaryPanel dp = new DictionnaryPanel();
		dp.init( ( HashMap )value );

		if ( DialogManager.showDialog(
			EditorModel.MAIN_FRAME,
			"Values",
			"Values",
			"Set your visible value",
			null,
			dp ) == DialogManager.OK_ID ) {

			dp.stopEditing();
			listener.stop();

		} else

			listener.cancel();
	}	

}
