package com.japisoft.xmlform.editor;

import com.japisoft.framework.ApplicationException;
import com.japisoft.framework.ApplicationMain;
import com.japisoft.framework.step.InterfaceBuilderStep;
import com.japisoft.framework.step.LookAndFeelStep;
import com.japisoft.framework.ui.toolkit.FileManager;
import com.japisoft.xmlform.editor.step.FrameBuildingStep;
import com.jgoodies.looks.plastic.Plastic3DLookAndFeel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Main extends ApplicationMain {

	/**
	 * @param args */
	public static void main(String[] args) {

		
		new EditorModel( args );
		
		EditorModel.addApplicationStep(
				new LookAndFeelStep( 
					Plastic3DLookAndFeel.class.getName() ) );

		System.out.println( "Running Editor" );

		EditorModel.addApplicationStep(
				new InterfaceBuilderStep(
					Main.class.getResource( "xfe.xml" ) ) );

		EditorModel.addApplicationStep(
				new FrameBuildingStep()
		);

		FileManager.setPreferenceForLastFilePath( true );		

		try {

			Main.start( args );
			
		} catch ( ApplicationException e ) {
			e.printStackTrace();
		}

	}

}
