package com.japisoft.xmlform.editor.actions.file;

import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileWriter;

import com.japisoft.framework.internationalization.Traductor;
import com.japisoft.framework.ui.toolkit.FileManager;
import com.japisoft.xmlform.UIToolkit;
import com.japisoft.xmlform.editor.EditorModel;
import com.japisoft.xmlform.editor.actions.CommonAction;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SaveAction extends CommonAction {

	public void actionPerformed2(ActionEvent e) {
		if ( EditorModel.CURRENT_DOCUMENT == null ) {
			File f = FileManager.getSelectedFile( 
					true,
					"xml",
					"XML Document" );
			EditorModel.CURRENT_DOCUMENT = f.toString();
		}
		if ( EditorModel.CURRENT_DOCUMENT != null )
			saveTo( EditorModel.CURRENT_DOCUMENT );		
	}

	public void saveTo( String uri ) {
		try {
			frame.saveDocument( uri );
		} catch ( Exception e ) {
			UIToolkit.dispatchError( Traductor.traduce( "cantsave", "Can't save" ) + " : " + e.getMessage() );
		}
	}

	public static void main( String[] args ) throws Exception {
		
		System.out.println( "Test criture" );
		
		String p = "\\\\d-siteorsys-xp\\cours-xml\\ACE.xml";
		
		FileWriter fw = new FileWriter( new File( p ) );
		try {
			fw.write( "TEST" );
		} finally {
			fw.close();
		}
		
	}
	
}
