package com.japisoft.xmlpad;

import javax.swing.JPopupMenu;
import javax.swing.JSplitPane;
import javax.swing.JToolBar;
import javax.swing.JTree;

import com.japisoft.xmlpad.editor.XMLEditor;
import com.japisoft.xmlpad.elementview.ElementView;
import com.japisoft.xmlpad.error.ErrorView;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class BasicUIAccessibility implements UIAccessibility {

	XMLContainer container;

	BasicUIAccessibility(XMLContainer container) {
		this.container = container;
	}

	public JSplitPane getSplitPane() {
		return container.mainSplitPane;
	}

	public void setInitialTreeTextDividerLocation(double location) {
		container.setInitialTreeTextDividerLocation(location);
	}

	public void setInitialElementViewDividerLocation(double location) {
		container.setElementViewDividerLocation(location);
	}

	public JSplitPane getSecondarySplitPane() {
		return container.elementSplitPane;
	}

	public boolean isPopupAvailable() {
		return container.isPopupAvailable();
	}

	public boolean isToolBarAvailable() {
		return container.isToolBarAvailable();
	}

	public boolean isToolBarVisible() {
		return container.isToolBarVisible();
	}

	public boolean isTreePopupAvailable() {
		return container.isTreePopupAvailable();
	}

	public void setPopupAvailable(boolean popupAvailable) {
		container.setPopupAvailable(popupAvailable);
	}

	public void setToolBarAvailable(boolean toolBarAvailable) {
		container.setToolBarAvailable(toolBarAvailable);
	}

	public void setToolBarVisible(boolean toolbarVisible) {
		container.setToolBarAvailable(toolbarVisible);
	}

	public void setTreePopupAvailable(boolean treePopupAvailable) {
		container.setTreePopupAvailable(treePopupAvailable);
	}

	public JPopupMenu getCurrentPopup() {
		return container.getCurrentPopup();
	}

	public JPopupMenu getCurrentTreePopup() {
		return container.getCurrentTreePopup();
	}

	public XMLEditor getEditor() {
		return container.getEditor();
	}

	public JToolBar getToolBar() {
		return container.getToolBar();
	}

	public JToolBar getTreeToolBar() {
		return container.treeToolbar;
	}

	public JTree getTree() {
		return container.getTree();
	}

	public boolean isTreeAvailable() {
		return container.isTreeAvailable();
	}

	public boolean isTreeVisible() {
		return container.isTreeVisible();
	}

	public void setTreeAvailable(boolean treeAvailable) {
		container.setTreeAvailable( treeAvailable );
	}

	public void setTreeDelegate(JTree treeDelegate) {
		container.setTreeDelegate( treeDelegate );
	}

	public void setTreeVisible(boolean treeVisible) {
		container.setTreeVisible( treeVisible );
	}

	public void setTreeToolBarAvailable(boolean treeToolBarAvailable) {
		container.treeToolBarAvailable = treeToolBarAvailable;
	}

	public boolean isTreeToolBarAvailable() {
		if ( container == null )
			return false;
		return container.treeToolBarAvailable;
	}

	public ErrorView getErrorView() {
		return container.getErrorView();
	}

	public void setErrorView(ErrorView view) {
		container.setErrorView( view );
	}

	public ElementView getElementView() {
		return container.getElementView();
	}

	public void setElementView(ElementView view) {
		container.setElementView( view );
	}

	public void dispose() {
		this.container = null;
	}

	private boolean enableDragNDropForRoot = false;
	
	public void setEnableDragNDropForRoot( boolean enabled ) {
		enableDragNDropForRoot = enabled;
	}
	
	public boolean isEnabledDragNDropForRoot() {
		return enableDragNDropForRoot;
	}
	
	
}
