package com.japisoft.xmlpad.action.edit;

import javax.swing.JOptionPane;

import com.japisoft.xmlpad.action.XMLActionForSelection;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FastCommentUncommentAction extends XMLActionForSelection {

	public static final String ID = FastCommentUncommentAction.class.getName();
	
	public boolean notifyAction() {
		String selection = container.getEditor().getSelectedText();
		try {
		if ( selection != null ) {
			String newContent = null;
			if ( selection.startsWith( "<!--" ) 
				&& selection.endsWith( "-->" ) ) {
				newContent = selection.substring( 4, selection.length() - 3 );
			} else {
				if ( selection.indexOf( "<!--" ) > -1 ) {
					JOptionPane.showMessageDialog( container.getView(), "You must remove the comment part before operating", "Error", JOptionPane.ERROR_MESSAGE );
					return false;
				} else
					newContent = "<!--" + selection + "-->";
			}
			container.getEditor().replaceSelection( newContent );
			return true;
		} else
			JOptionPane.showMessageDialog( container.getView(), "No selection found", "Error", JOptionPane.ERROR_MESSAGE );
		} catch( Throwable th ) {
			System.err.println( "Can't comment/uncomment" );
		}
		return false;
	}
	
}
 
