package com.japisoft.xmlpad.action.edit;

import javax.swing.JOptionPane;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.action.XMLAction;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SelectTagAction extends XMLAction {

	public static final String ID = SelectTagAction.class.getName();
	
	protected boolean autoRequestFocus() { return false; }

	public boolean notifyAction() {
		if ( container.getTreeListeners() == null )
			return INVALID_ACTION;
		if ( container.getTree() == null )
			return INVALID_ACTION;
		if  ( container.getTree().getSelectionPath() == null )
			return INVALID_ACTION;
		FPNode n = ( FPNode )container.getTree().getSelectionPath().getLastPathComponent();
		if (n == null) {
			JOptionPane.showMessageDialog( container.getView(), "No Tag Found", "Error", JOptionPane.ERROR_MESSAGE );
			return INVALID_ACTION;
		}
		selectNode( container, n );
		return VALID_ACTION;		
	}
	
	public static void selectNode( 
			XMLContainer container, 
			FPNode n ) {
		if ( n == null )
			return;
		int start = n.getStartingOffset();
		int stop = n.getStoppingOffset();
		if ( n.isTag() )
			stop++;
		container.getEditor().requestFocus();
		container.getEditor().select( start, stop );		
	}

}
