package com.japisoft.xmlpad.action.search;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.*;

import javax.swing.*;

import com.japisoft.xmlpad.action.XMLAction;
import com.japisoft.xmlpad.dialog.DialogManager;
import com.japisoft.xmlpad.look.LookManager;
import com.japisoft.xmlpad.tree.TreeListeners;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SearchAction extends XMLAction {

	public static final String ID = SearchAction.class.getName();
	
	public SearchAction() {
		super();
	}

	public boolean notifyAction() {
		JTree t = new JTree();
		LookManager.install( container,t);
		TreeListeners p = new TreeListeners(container, t);
		p.setPopupEnabled( false );
		t.addMouseListener(p);
		p.notifyStructureChanged();

		DialogManager.showDialog(
				SwingUtilities.getWindowAncestor( container.getView() ),
				"Search",
				"Locate a node",
				"Click on a node for highlighting the same editor line",
				null,
				new TreePane( t, p ) );
		
		t.removeMouseListener(p); //JPF
		return VALID_ACTION;
	}

	////////////////////////////////////////////

	/** Tree document */
	class TreePane extends JPanel {
		private int lastCaret = 0;
		private TreeListeners rtt;

		public TreePane( JTree tree, TreeListeners p ) {
			setLayout( new BorderLayout() );
			add( new JScrollPane( tree ) );

			rtt = p;

			setPreferredSize( new Dimension( 300, 400 ) );
			
			tree.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					if (e.getClickCount() > 1) {
						rtt.mouseClicked(e);
					}
				}
			});
		}
	}

}

// SearchAction ends here
