package com.japisoft.xmlpad.editor;

import java.util.Vector;

import javax.swing.text.Segment;

// Cache for big lines */
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
final class LineParsingCache {

	private static final int LINE_BOUND = 100;
	private static final boolean ENABLED = false;
	static final int CACHE_SIZE = 5;
	static int[] storedLineLocation = new int[ CACHE_SIZE ];
	static int[] storedLineSize = new int[ CACHE_SIZE ];
	static Vector[] storedParsingResult = new Vector[ CACHE_SIZE ];
	static int cacheLocation = -1;
	static int cacheSize = 0;
	
	static Vector getParsedLine( Segment line, int lineLocation ) {
		if ( line.count > LINE_BOUND && ENABLED ) {
			for ( int i = 0; i < cacheSize; i++ ) {
				if ( storedLineLocation[ i ] == lineLocation && 
						storedLineSize[ i ] == line.count ) {
					return storedParsingResult[ i ];
				}
			}
		}
		return null;
	}
	
	static void updateCache( Segment line, int location, Vector v ) {
		if ( line.count > LINE_BOUND && ENABLED ) {
			
			// In cache already ?
			for ( int i = 0; i < cacheSize; i++ ) {
				if ( storedLineLocation[ i ] == location && storedLineSize[ i ] == line.count ) {
					return;
				}
			}

			System.out.println( "UPDATED CACHE");
			
			cacheLocation = ( cacheLocation + 1 ) % CACHE_SIZE;
			cacheSize = Math.max( cacheSize, cacheLocation + 1 );
			storedLineLocation[ cacheLocation ] = location;
			storedLineSize[ cacheLocation ] = line.count;
			storedParsingResult[ cacheLocation ] = ( Vector )v.clone();
		}
	}

}
