package com.japisoft.xmlpad.elementview;

import javax.swing.JComponent;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.error.ErrorListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface ElementView extends ErrorListener {

	/** Initialize this view with a context for interacting with the XMLContainer */
	public void init( ElementViewContext context );

	/** @return the main view for this element */
	public JComponent getView();

	/** Update the view content with this node */
	public void updateView( FPNode node );

	/** @return <code>true</code> is this view doesn't need to be inside a JScrollPane and <code>false</code> else */
	public boolean autoScroll();

	/** Dispose inner resource like the context */
	public void dispose();
	
	/** Make this element view editable */
	public void setEditable( boolean editable );
	
}
