package com.japisoft.xmlpad.error;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DefaultErrorView extends JPanel implements ErrorView {

	private JLabel lbl = new JLabel( "?" );

	public DefaultErrorView() {
		super();
		setLayout( new BorderLayout() );
		add( lbl );
		lbl.setForeground( Color.red );
		lbl.setFont( new Font( null, 0, 12 ) );
	}

	void setErrorMessage( String error ) {
		lbl.setText( error );
		lbl.setToolTipText( error );
	}	

	public JComponent getView() {
		return this;
	}

	/** Don't show by default */
	public boolean isShownForOnTheFly() {
		return false;
	}	

	/** Not managed */
	public void addErrorSelectionListener( ErrorSelectionListener listener ) {
	}

	/** Not managed */
	public void removeErrorSelectionListener( ErrorSelectionListener listener ) {
	}

	/** Not managed */
	public void initErrorProcessing() {}

	/** Not managed */
	public void stopErrorProcessing() {
	}	
	
	public void notifyError(
			Object context,
			boolean localError,
			String sourceLocation, 
			int line, 
			int column,
			int offset,
			String message,
			boolean onTheFly ) {
		if ( !onTheFly )
			setErrorMessage( message );
	}

	/** Not managed */
	public void notifyNoError( boolean onTheFly ) {
	}
	
	public void dispose() {
	}
	
	public void initOnceAdded() {
	}	
}
