package com.japisoft.xmlpad.helper.handler.system;

import java.util.List;

import com.japisoft.framework.xml.parser.document.Document;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.editor.XMLPadDocument;
import com.japisoft.xmlpad.helper.model.AttDescriptor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DefaultAttributeHandler extends AbstractSystemHandler {

	@Override
	protected void installDescriptors(FPNode currentNode,
			XMLPadDocument document, int offset, String activatorString) {
		if ( currentNode != null ) {
			String tag = currentNode.getNodeContent();
			Document d = currentNode.getDocument();
			if ( d != null ) {
				List<String> l = d.getOrderedAttributes( tag );
				for ( int i = 0; i < l.size(); i++ ) {
					addDescriptor( new AttDescriptor( l.get( i ), null ) );
				}
			}
		}							
	}
	
	@Override
	protected String getActivatorSequence() {
		// TODO Auto-generated method stub
		return null;
	}
	
	public boolean haveDescriptors(
			FPNode currentNode,
			XMLPadDocument document,
			boolean insertBefore,
			int offset,
			String activatorString ) {
		if ( null == activatorString ) {
			if ( !document.hasSchema() ) {
				if ( document.isInsideTag( offset, true, true ) ) {
					return true;
				}
			}			
		}
		return false;
	}
	
}
