package com.japisoft.xmlpad.helper.handler.system;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.editor.XMLPadDocument;
import com.japisoft.xmlpad.helper.handler.schema.AbstractEntityHandler;
import com.japisoft.xmlpad.helper.model.EntityDescriptor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DefaultEntityHandler extends AbstractEntityHandler {
	
	protected void installDescriptors(
			FPNode currentNode,
			XMLPadDocument document, 
			int offset,
			String addedString ) {

		addDescriptor(
				new EntityDescriptor( addedString + "gt", ">" ) );

		addDescriptor(
				new EntityDescriptor( addedString + "lt", "<" ) );
		
		addDescriptor(
				new EntityDescriptor( addedString + "quot", "\"" )
				);

		addDescriptor(
				new EntityDescriptor( addedString + "amp", "&" )
				);		

		addDescriptor(
				new EntityDescriptor( addedString + "apos", "'" )
				);		

		addDescriptor(
				new EntityDescriptor( addedString + "#10", "Line break" )
				);		

	}	
	
	public String getName() {
		return "system-entities";
	}	
	
	public String getTitle() {
		return "Default entities";
	}

}
