package com.japisoft.xmlpad.helper.model;

import java.awt.Color;

import javax.swing.Icon;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BasicDescriptor extends TagDescriptor {

	public BasicDescriptor( String label, String raw ) {
		super( label, raw );
	}
	
	/**
	 * @param content raw content
	 */
	public BasicDescriptor( String content ) {
		super( content + "", null, false, true );
	}
	
	public BasicDescriptor( String content, Color color ) {
		super( content + "", null, false, true );
		this.color = color;
	}

	public BasicDescriptor( String content, Icon icon ) {
		super( content + "", null, false, true );
		this.setIcon( icon );
	}

	/**
	 * @param content Row content
	 * @param automaticNextHandler decide to activate after inserting another handler
	 */
	public BasicDescriptor( String content, boolean automaticNextHandler ) {
		super( content, null, false, true );
		setAutomaticNextHelper( automaticNextHandler );
	}
	
}
