// (c) ALEXANDRE BRILLANT : http://www.japisoft.com
// All this work is confidential, you have rights to
// change and evolve it for your products but you
// have no rights to sell it, propose concurrent works.
// Morever any changes to bugs or evolutions should
// be send to JAPISOFT that needs to maintain a
// valid version and has all rights on the product.


package com.japisoft.xpath;

import com.japisoft.xpath.function.Lib;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface XPathKit {

    /** @return the library resolver */
    public Lib getLibrary();

    /** @return the tree navigator toolkit */
    public Navigator getNavigator();

    // Particular methods

    /**
     * @param refNode a reference document element
     * @param id ID value to match
     * @return the node with the unique ID. The ID scope is theorically
     * limited to attribute defined as ID in the DTD
     */
    public Object getNodeForId( Object refNode, String id );


    /** Compute the string-value for this node */
    public String getStringValue( Object node );

    /** Compute the local name of the node */
    public String getLocalName( Object node );

    /** Compute the namespace URI for this node */
    public String getNamespaceURI( Object node );

    /** Compute the qualified name for this node */
    public String getName( Object node );

    /** Compute the language for this node */
    public String getLang( Object node );

    /** Set a feature support for the current kit. A RuntimeException
     * should be thrown by the kit that doesn't support such feature */
    public void setFeature( String feature, boolean enable );

    /** @return true if the feature is supported by the kit */
    public boolean isFeatureSupported( String feature );

    /** Return a list of supported features */
    public String[] getSupportedFeatures();
    
    /** Replace the reference node by another one */
    public Object getBetterReferenceNode( Object node );
}

// XPathKit ends here

