// (c) ALEXANDRE BRILLANT : http://www.japisoft.com
// All this work is confidential, you have rights to
// change and evolve it for your products but you
// have no rights to sell it, propose concurrent works.
// Morever any changes to bugs or evolutions should
// be send to JAPISOFT that needs to maintain a
// valid version and has all rights on the product.

package com.japisoft.xpath.function.basic;

import com.japisoft.xpath.function.*;
import com.japisoft.xpath.XPathContext;
import com.japisoft.xpath.FastVector;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public final class SubString extends AbstractFunction {
	public SubString() {
		super();
	}

	public Object eval(XPathContext context, FastVector arg) {
		int narg = arg.size();
		if (narg < 2) {
			throw new RuntimeException("Invalid parameters in " + this);
		} else {
			java.lang.String s = null;
			double p1 = 0;
			double p2 = 0;

			try {
				if (narg == 2) {
					s = (java.lang.String) arg.elementAt(1);
					p1 = ((Double) arg.elementAt(0)).doubleValue();
				} else if (narg == 3) {
					s = (java.lang.String) arg.elementAt(2);
					p1 = ((Double) arg.elementAt(1)).doubleValue();
					p2 = ((Double) arg.elementAt(0)).doubleValue();
				} else {
					return "";
				}

				try {

					if ( p1 <= 0 ) {
						p2 -= ( 1 - p1 );
						p1 = 1; 
					}

					if ( Double.isInfinite( p2 ) ) {
						p2 = s.length(); 
					}

					if (p2 == 0.0)
						return s.substring((int) Math.ceil(p1) - 1);
					else
						return s.substring((int) Math.ceil(p1) - 1, (int) Math
								.ceil(p1 + p2) - 1);

				} catch (IndexOutOfBoundsException exc) {
					return "";
				}

			} catch (ClassCastException exc) {
				throw new RuntimeException(
						"Invalid parameter usage for the substring function");
			}
		}
	}
}
// Contains ends here
